/*
 * Formation fv1600 Token-Ring Driver
 *
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ident "$Revision: 1.48 $"

/* do not compile for IP20/IP22 (no VME)
 */
#if !defined(IP20) && !defined(IP22)

/* #define FV_CAF	1 */
#ifdef _IRIX4
#define LLC223	1
#else
#define	HOSTLLC	1
#endif

/* #define DBG_LVL 1 */
/* #define IFRMTRC 1 */
/* #define IFRMRCV 1 */
/* #define IFRMDBG 1 */
/* #define IWAITDBG 1*/

#define QDBG	1

/* delay 1000usec for iframe xmit */
#define SLOWDOWN	DELAY(1000)
#define XDP(a)
#define IDP(a)

#if defined(R4000) || defined(TFP) || defined(R10000)
#define	VMEIN(s,t,l)	hwcpin(s,t,l)
#define	VMEOUT(s,t,l)	hwcpout(s,t,l)
#else
#define	VMEIN(s,t,l)	bcopy(s,t,l)
#define	VMEOUT(s,t,l)	bcopy(s,t,l)
#endif

#include "tcp-param.h"
#include "sys/types.h"
#include "sys/time.h"
#include "sys/cmn_err.h"
#include "sys/debug.h"
#include "sys/cpu.h"
#include "sys/sbd.h"
#include "sys/immu.h"
#include "sys/pda.h"
#include "sys/vmereg.h"
#include "sys/param.h"
#include "sys/kmem.h"
#include "sys/ddi.h"
#include "sys/systm.h"
#include "sys/mbuf.h"
#include "sys/socket.h"
#include "sys/errno.h"
#include "sys/edt.h"
#include "sys/kopt.h"
#include "sys/invent.h"
#ifndef _IRIX4
#include "sys/pio.h"
#include "sys/dmamap.h"
#endif /* _IRIX4 */
#include "sys/stream.h"
#include "sys/strmp.h"
#include "bstring.h"
#include "net/soioctl.h"
#include "net/if.h"
#include "net/if_types.h"
#include "net/netisr.h"
#include "sys/par.h"
#include "net/raw.h"
#include "net/multi.h"
#include "net/route.h"
#include "netinet/in.h"

#include "netinet/if_ether.h"
#include "ether.h"
#include "sys/tr.h"
#include "sys/llc.h"
#include "sys/fddi.h"
#include "sys/tms380.h"
#include "sys/tr_user.h"
#ifdef _IRIX4
#ifdef FV_CAF
#include "sys/if_fv_caf.h"
#endif
#ifdef LLC223
#include "sys/if_fv_llc.h"
#endif
#else	/* _IRIX4 */
#ifdef FV_CAF
#include "fv_caf/if_fv_caf.h"
#endif
#ifdef LLC223
#include "fv_caf/if_fv_llc.h"
#endif
#include "sys/dlsap_register.h"
#endif	/* _IRIX4 */
#include "sys/capability.h"
#ifdef IFRMTRC
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#endif

#ifdef QDBG
struct tr_qs fvqs;
struct tr_ints fvints;
struct tr_ifx fvifx;

#define QDBGUP(a,b)	(a)+=(b)
#define QDBGMSG(a)	printf a
#define QDBGHW(a,b)	if ((a) > (b)) b = (a)
#else
#define QDBGUP(a,b)
#define QDBGMSG(a)
#define QDBGHW(a,b)
#endif

extern struct ifqueue ipintrq;		/* ip packet input queue */

extern time_t lbolt;
extern struct ifnet loif;

/* lboot variables */
extern int fv_mtu;
extern int fv_batype;
extern u_short fv_bc_mask;
extern int tr_timer_t1_1, tr_timer_t2_1, tr_timer_ti_1;
extern int tr_timer_t1_2, tr_timer_t2_2, tr_timer_ti_2;

struct fv_info;			/* forward reference */
#if (DBG_LVL >= DBG_LVL_DRV)
#ifdef FV_CAF
static void fv_dumprbuf(struct fv_info*);
#endif
clock_t fv_edt_time0;
clock_t fv_edt_time1;
#endif
static int fv_open_ip_sap(struct fv_info *);
static int fv_getscb(struct fv_info*);
static int fv_receive(struct fv_info*);
static int fv_transmit(struct fv_info*);
static void fv_process_ring_status(struct fv_info*, SSB*);
static void tr_process_cmd_status(struct fv_info*, SSB*);
static int tr_process_rcv_status(struct fv_info*, SSB*);
static int fv_recv(struct fv_info*, volatile struct tr_rcv_list*);
static int tr_process_xmit_status(struct fv_info*, SSB*);
static int fv_process_rcv_pending(struct fv_info*);
static void fv_process_llc_status(struct fv_info*, TR_ICB*);
static volatile struct tr_xmit_list *fv_free_xmitlist(struct fv_info*, volatile struct tr_xmit_list*);
static int fvIssueCmd(struct fv_info*, int, u_int);
static void fv_setxbuf(struct fv_info*);
static void fv_setrbuf(struct fv_info*);
static void tr_format_open_block(struct fv_info*);
static int fvsend(caddr_t, struct fv_info*, u_short, u_short, u_short, u_short, int, u_char, int);
static int fvpacksend(caddr_t packet, struct fv_info *fv, u_short ftype, u_short station_id, u_short sap, u_short packet_type, register int frame_len, u_char correlator, int hdrlen, int rlen, TR_MAC_HDR *mh);
static volatile struct tr_rcv_list *fv_get_rcvlist(struct fv_info*, int, int);
static int fv_close(struct fv_info*, int);
static void fvreset(struct fv_info*, int);
static void fvstart1(struct fv_info *);
static void fvstart2(struct fv_info *);
static void fvstart3(struct fv_info *);
static void fvstart4(struct fv_info *);
static void fv_lli(struct mbuf *);
static void fv_ifr_intr(struct mbuf*);
static void fv_ifr_stat(struct mbuf*);
static void fv_wakeupclose(struct fv_info *fv);

static int fv_valid_unit(int);
static char *fv_get_sa(int);
static int fv_lli_output(u_short, SCB*);

#ifdef IFRMDBG
IFRAMES fvifr0[0xff];
mblk_t	fvmb0[0xff];
struct	datab fvdp0[0xff];
char	fvmd0[0xff][128];
u_int	fvnxtcorel = 0xfe;
u_int	fv_scorel = 1;
#endif
#ifdef IWAITDBG
int	babble = 0;
#define IWMSG(a)	printf a
#else
#define IWMSG(a)
#endif

#ifdef IFRMTRC
extern void fv_ifrm_trace(char*);
#define IFRM_TRC(a) fv_ifrm_trace(a)

#define fv_ifrm_size 500
char fv_ifrm_buf[fv_ifrm_size][8];
u_int fv_ifrm_cnt = 0;
int fv_ifrm_idx = 0;

void fv_ifrm_trace(char *ifrm)
{
    bcopy(ifrm, fv_ifrm_buf[fv_ifrm_idx], 8);
    if (++fv_ifrm_idx >= fv_ifrm_size)
	fv_ifrm_idx = 0;
    fv_ifrm_cnt++;
}
#endif

#define FV_MAXBD   		4	/* allow this many boards */

static char fv_baddr_c[6] = {0xc0, 0x00, 0xff, 0xff, 0xff, 0xff};
static char fv_baddr_f[6] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};

/* flags to distinguish between IP and SNA packets */
#define	TR_IP_PACKET	0x01
#define	TR_SNA_PACKET	0x02
#define TR_DROP_PKT	0x04

/* macros to traverse the transmit and receive lists */
#define TR_NEXT_XMITLIST(fv, xl, mem)					\
	((volatile struct tr_xmit_list *) 					\
	(((__psunsigned_t)xl == (__psunsigned_t)&mem->fv_xlist[TR_XMIT_LISTS-1]) ?	\
		(__psunsigned_t)&mem->fv_xlist[0]: ((__psunsigned_t)xl+TR_LIST_SIZE)))

#define TR_NEXT_RCVLIST(fv, rl, mem)					\
	((volatile struct tr_rcv_list *)				\
	(((__psunsigned_t)rl == (__psunsigned_t)&mem->fv_rlist[TR_RCV_LISTS-1]) ?	\
		(__psunsigned_t)&mem->fv_rlist[0]: ((__psunsigned_t)rl+TR_LIST_SIZE)))

#define TR_PREV_XMITLIST(mem, xl)					\
	(((__psunsigned_t)xl == (__psunsigned_t)mem->fv_xlist) ? 			\
		(__psunsigned_t)&mem->fv_xlist[TR_XMIT_LISTS-1]:		\
		((__psunsigned_t)xl - TR_LIST_SIZE))

#define TR_PREV_RCVLIST(mem, rl)					\
	(((__psunsigned_t)rl == (__psunsigned_t)mem->fv_rlist) ? 	\
			(__psunsigned_t)&mem->fv_rlist[TR_RCV_LISTS-1]:	\
			((__psunsigned_t)rl - TR_LIST_SIZE))

#define CHKXL(x) ASSERT((x>=&mem->fv_xlist[0])&&(x<=&mem->fv_xlist[TR_XMIT_LISTS-1]))
#define CHKRL(r) ASSERT((r>=&mem->fv_rlist[0])&&(r<=&mem->fv_rlist[TR_RCV_LISTS-1]))
#define CHKDB(d) ASSERT((d>=&mem->tr_data_buf[0])&&(d<=&mem->tr_data_buf[TR_DATA_BUFFERS-1]))

#define RUP(l,m) (((l)+(m)-1)/(m))

#define BDINT(b,h) { u_short *sp = (u_short*)&b; \
	sp[0] = htons((u_int)h>>16); sp[1] = htons((u_int)h&0xffff); }
#define BDMEM(a,t) (t)((__psunsigned_t)&fv->fv_mem->a - (__psunsigned_t)fv->fv_mem)

#define HTINT(h,b) { u_short *sp = (u_short*)&b; u_long *tp = (u_long*)&h;\
	*tp=(u_long)(ntohs(sp[0])<<16)+(ulong)ntohs(sp[1]); }
#define HTMEM(b,t) (t)((u_long)b+(u_long)fv->fv_mem)
#define IOBP(b,t) \
	(t)(((u_int)b.address_high<<16)+(u_int)b.address_low+(__psunsigned_t)mem)
#define LISTP(b,t) (t)((b->ssb_parm1<<16)+b->ssb_parm2+(__psunsigned_t)mem);

/* expected values of ssb and scb after initialization */
static u_char prodid[] = {
	0x09,						/* product class */
	0x10,						/* format type */
	0xe2, 0xc7, 0xc9, 0x00, 			/* machine type */
	0x00, 0x00, 0x00,				/* machine number */
	0x00, 0x00,					/* Serial number */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	/* sequence number */
};
u_char 	tr_piscb[] = { 0x00, 0x00, 0xc1, 0xe2, 0xd4, 0x8b };
u_char 	tr_pissb[] = { 0xff, 0xff, 0xd1, 0xd7, 0xc5, 0xd9, 0xc3, 0xd4 };

/* Specific Open Phase errors */
static char *OpenPhases[6] = {
	" ",
	"Lobe media test",
	"Physical insertion",
	"Address verification",
	"Participation in ring poll",
	"Request Initialization"
};

static char *OpenErrs[11] = {
	" ",
	"Function failure",
	"Signal loss",
	"",
	"",
	"Timeout",
	"Ring failure",
	"Ring beaconing",
	"Duplicate node address",
	"Request initialization",
	"Remove received"
};

/*
 * FV1600 short io registers
 */
typedef volatile struct {
	u_short	sifdat;		/* TMS380 SIFDAT register */
	u_short	null;		
	u_short	sifdat_inc;	/* TMS380 SIFDAT/INC register */
	u_short	sifcmd_stat;	/* TMS380 SIFCMD/STATUS register */
	u_short	actl;		/* TMS380 ACTL register */
	u_short	sifadrx;	/* TMS380 SIFADRX register */
	u_short sifadr;		/* TMS380 SIFADR register */
	u_short	regs_gap[22];
	u_char	pad_status;	/* status register is 1-char long */
#define	TR_POC_IN_PROGRESS	0x00	/* reset procedure in progress */
#define	TR_POC_COMPLETE_OK	0x80	/* reset completed ok */
#define	TR_POC_MAX_ERR_CODE	0x0d	/* max reset error number*/
#define	TR_NO_RESPONSE		0xff	/* return value if probe failed */
	u_char	vme_status;	/* vme interface status register */
	u_char	pad_reset;	/* reset register is 1-char long */
#define TR_RESET_CODE		0xa5	/* board reset code */
	u_char	vme_reset;	/* vme interface reset register */
} FVIO;

/*----------------------------------------------------------------------*
 *	Shared VME memory buffer memory structure			*
 *									*
 *		SCB 			 	     0 	- 8		*
 *		SSB				     8 	- 0x10		*
 *		General parameter block		  0x10 	- 0x50		*
 *		Product ID		 	  0x50	- 0x70		*
 *		Error Log			  0x70 	- 0x80	  	*
 *		Receive list			  0x80	- 0x880		*
 *		Transmit list			 0x880	- 0x1400	*
 *		Receive/Transmit buffers	0x1400	- 0x20000	*
 *----------------------------------------------------------------------*/
typedef volatile struct {
	SCB 	tr_scb;	/* 8 */
	SSB 	tr_ssb;	/* 8 */
	struct tr_open_block	 		open_block; /* 64 */
	struct tr_error_log	 		tr_error_log; /* 16 */
    	struct tr_open_sap_block		open_sap_block; /* 32 */
    	struct tr_open_station_block		open_station_block; /* 20 */
    	struct tr_connect_station_block 	conn_stn_block; /* 8 */
    	struct tr_llc_statistics_block		llc_stats_block; /* 24 */
	struct tr_product_id			tr_product_id; /* 32 */
	u_char 				tr_reserved[TR_BUFM_RESERVED];

	union {
		char	rlimit[2048];
		volatile struct tr_rcv_list	 recv_list[TR_RCV_LISTS];
	} r_u;
	union {
		char	xlimit[2048];
		volatile struct tr_xmit_list	 xmit_list[TR_XMIT_LISTS];
	} x_u;
	struct tr_data_buf	 tr_data_buf[TR_DATA_BUFFERS];
} FVMEM;
#define fv_rlist	r_u.recv_list
#define fv_xlist	x_u.xmit_list

/*
 * Token Ring internal data structure
 */
struct fv_info {
	struct trif	fv_tif;		/* common TR interface structure */
#define fv_ac		fv_tif.tif_arpcom
#define fv_rawif 	fv_tif.tif_rawif
#define fv_bia		fv_tif.tif_bia
#ifdef XXX
	struct arpcom	fv_ac;		/* common interface structure */
	struct rawif	fv_rawif;
	char		bia[TR_MAC_ADDR_SIZE];
#endif
	FVOHDR		tr_hdr;		/* prototype MAC & LLC header */

	u_char		fv_vector;	/* VME interrupt vector */
	u_char		fv_brl;		/* interrupt vector level */

#define	TR_16_MBIT		0x00000001	/* 16 - 4 Mbit mode */
#define TR_EDTINIT		0x00000002	/* For first reset only */
#define TR_PROMISC		0x00000004	/* promisc mode */
#define TR_HARDRESET		0x00000008	/* hard reset */
#define TR_ONCHIPLLC		0x00000010	/* use on chip llc */
	u_int		flags;		/* miscellaneous flags */

	TR_GRPADDR	tr_grp_addr;
	TR_FCNADDR	tr_fcn_addr;

	FVIO		*FVIO;			/* fv1600 regs virtual addr */
	FVMEM		*fv_mem;		/* fv1600 buffer memory */

	int	n_free_xmitlist;		/* # of free xmit lists */
	volatile struct	tr_xmit_list *xmitlist_first;	/* first xmit list chain */
	volatile struct	tr_xmit_list *xmitlist_last;	/* last xmit list chain */
	volatile struct	tr_xmit_list *xmitlist_free;	/* next available xmit list */

	int	n_free_rcvlist;			/* # of free rcv lists */
	volatile struct	tr_rcv_list *rcvlist_first;	/* first rcv list chain */
	volatile struct	tr_rcv_list *rcvlist_free;	/* next available rcv list */

	TR_STATUS fv_statlog;			/* statistical data */

#define FV_STATE_RESET		0x00	/* device is resetting */
#define FV_STATE_INIT		0x01	/* device is initializing */
#define FV_STATE_OPEN		0x02	/* device is being opened */
#define FV_STATE_OPENSAP	0x03	/* IP sap is being opened */
#define FV_STATE_OK		0x04	/* device is transmitting & receiving */
#define FV_STATE_CLOSE		0x05	/* device is transmitting & receiving */
#define FV_STATE_SICK		0x80	/* device is broken */
	u_int		fv_state;	/* useful state bits */
	int		rtry;		/* # of init retries */

#define TR_INCR_TIMEOUT         HZ
#define TR_RESET_TIMEOUT        35
#define TR_OPEN_TIMEOUT         20
	int		reset_tid;
	time_t		resettimo;	/* timeout time of last rcv */
	int		inittimo;

#define	CMD_BUSY	0x1
#define	CMD_CANWAIT	0x2
#define	CMD_PENDING	0x4
#define	CMD_HANG	0x8
#define TR_MAX_CMDS	0x24
	u_int		cmd_Flags[TR_MAX_CMDS];	/* pending wait */
	u_int		cmd_Status[TR_MAX_CMDS];/* in progress wait */

	int		fv_vme_adapter;
	TMS_INTERNAL_ADDR ia;			/* internal addrs */

	u_short		ip_sid;
	u_short		fv_openop;

	u_int		alarm;
	struct mbuf	*alarm_mbuf;

	u_char	 mcl[10];		/* Micro Code Level */
	u_char	 pid[18];		/* Product ID */
	u_char   sid[4];		/* Station ID */

	u_short	nullsri;		/* default bcast sri */

	int		addrset;	/* MAC_SETADDR flag */
	int		naddrset;	/* IP_SETADDR flag */
} fv_info[FV_MAXBD];
#define fv_if		fv_ac.ac_if
#define fv_enaddr	fv_ac.ac_enaddr
#define fv_unit		fv_if.if_unit

typedef struct tokenbufhead {
	struct ifheader         tbh_ifh;
	struct snoopheader      tbh_snoop;
} TOKENBUFHEAD;

#if (DBG_LVL >= DBG_LVL_DRV) || defined(IFRMDBG)
static void
fv_hexdump(char *cp, int len)
{
	register int idx;
	register int qqq;
	char qstr[512];
	int maxi = 128;
	static char digits[] = "0123456789abcdef";

	if (len < maxi)
		maxi = len;
	for (idx = 0, qqq = 0; qqq<maxi; qqq++) {
		if ((qqq%16) == 0)
			qstr[idx++] = '\n';
		qstr[idx++] = digits[cp[qqq] >> 4];
		qstr[idx++] = digits[cp[qqq] & 0xf];
		qstr[idx++] = ' ';
	}
	qstr[idx] = 0;
	printf("%s\n", qstr);
}
#endif /* (DBG_LVL >= DBG_LVL_DRV) || defined(IFRMDBG) */

static void
fv_fetbdm(FVIO *io, u_short bda, u_short *sp, int siz)
{
	io->sifadrx = TR_INT_MEMORY_ADDR;
	io->sifadr = bda;
	for (siz = siz/sizeof(u_short); siz > 0; siz--, sp++)
		*sp = io->sifdat_inc;
}
static void
fv_stobdm(FVIO *io, u_short bda, u_short *sp, int siz)
{
	io->sifadrx = TR_INT_MEMORY_ADDR;
	io->sifadr = bda;
	for (siz = siz/sizeof(u_short); siz > 0; siz--, sp++)
		io->sifdat_inc = *sp;
}

#ifdef STR_DATAIN
/*------------------------------------------------------------------------*
 * Copy data to an mblk chain (starting at *wptr)			  *
 * continuing for "maxlen" bytes, from the indicated buffer.		  *
 *------------------------------------------------------------------------*/
static int					/* return # of bytes copied */
str_datain(caddr_t cp,			/* source buffer */
	   mblk_t *bp,			/* destination mblk */
	   int maxlen)			/* copy this many */
{
	int count;
	int done;
	int bplen;

	ASSERT(cp);
	ASSERT(bp);

	done = 0;
	/* First find an mblk in the chain with some space in it.
	 * If wptr is pointing at the end of buffer, then the mblk 
	 * is full, and we have to look at the next one in the chain.
	 */
	ASSERT(bp->b_wptr >= bp->b_rptr);
	ASSERT(bp->b_wptr <= bp->b_datap->db_lim);
	while (bp->b_wptr == bp->b_datap->db_lim) {
		ASSERT(bp->b_cont);
		bp = bp->b_cont;
	}

	/* compute length of data available in mblk (endofbuf - wptr) */
	ASSERT(bp->b_wptr <= bp->b_datap->db_lim);
	bplen = (__psunsigned_t)bp->b_datap->db_lim
						- (__psunsigned_t)bp->b_wptr; 
	while (maxlen > 0) {
		ASSERT(bp != 0);
		count = MIN(bplen, maxlen);
		if (count != 0) {
			ASSERT((bp->b_wptr + count) <= bp->b_datap->db_lim);
			if (count&1)
				bcopy(cp, (char *)(bp->b_wptr), count+1);
			else
				bcopy(cp, (char *)(bp->b_wptr), count);
			bp->b_wptr += count;
			maxlen -= count;
			cp += count;
			done += count;
		}
		bp = bp->b_cont;
	}
	return done;
}
#endif

static void
fv_setnullsri(struct fv_info *fv)
{
	if (fv_bc_mask == 0)
		fv->nullsri = (TR_RIF_ALL_ROUTES|0x200);
	else
		fv->nullsri = (fv_bc_mask|0x200);

	if (fv->fv_if.if_mtu >= 17800)
		fv->nullsri |= TR_RIF_LF_17800;
	else if (fv->fv_if.if_mtu >= 11407)
		fv->nullsri |= TR_RIF_LF_11407;
	else if (fv->fv_if.if_mtu >= 8144)
		fv->nullsri |= TR_RIF_LF_8144;
	else if (fv->fv_if.if_mtu >= 4472)
		fv->nullsri |= TR_RIF_LF_4472;
	else if (fv->fv_if.if_mtu >= 2052)
		fv->nullsri |= TR_RIF_LF_2052;
	else if (fv->fv_if.if_mtu >= 1470)
		fv->nullsri |= TR_RIF_LF_1470;
	else if (fv->fv_if.if_mtu >= 516)
		fv->nullsri |= TR_RIF_LF_516;
	else
		fv->nullsri |= TR_RIF_LF_INITIAL;
}

/*
 *  Initialize the boadr.
 */
static
if_fvinit(int unit)
{
	struct fv_info *fv = &fv_info[unit];
	struct ifnet *ifp = &fv->fv_if;
	ASSERT(IFNET_ISLOCKED(ifp));

	if ((ifp->if_flags & IFF_RUNNING) != 0) {
		DP(("if_fvinit%d: already running\n", fv->fv_unit));
		return(0);
	}

	if (fv->fv_state < FV_STATE_OK) {
		IFNET_UNLOCKNOSPL(ifp);
		sleep((caddr_t)&fv->fv_state, PZERO|PCATCH);
		IFNET_LOCKNOSPL(ifp);
	}
	if (fv->fv_state != FV_STATE_OK) {
		return(EIO);
	}
	ifp->if_flags |= (IFF_UP|IFF_RUNNING);
	return(0);
}

/*
 * get scb:
 */
static int
fv_getscb(struct fv_info *fv)
{
	register int err = 0;
	register FVMEM *mem = fv->fv_mem;
	while (mem->tr_scb.scb_cmd != 0) {
		DELAY(2);
		if (++err >= 5000) {	/* wait for 10 msec */
			DP(("fv%d: get scb failed, scb=x%x\n", 
				fv->fv_unit,mem->tr_scb.scb_cmd));
			return(EBUSY);
		}
	}
	return(0);
}

/*
 * open sap:
 */
static int
fv_open_sap(struct fv_info *fv, struct tr_open_sap_block *osb)
{
	VMEOUT((caddr_t)osb,(caddr_t)&fv->fv_mem->open_sap_block,sizeof(*osb));
	return(fvIssueCmd(fv, TR_CMD_OPEN_SAP, BDMEM(open_sap_block,u_int)));
}

/*
 * open IP SAP
 */
static int
fv_open_ip_sap(struct fv_info *fv)
{
	struct tr_open_sap_block osb;

	/* set open IP sap */
	bzero((caddr_t)&osb, sizeof(osb));
	osb.sap_value = TR_IP_SAP; 
	osb.sap_options = TR_OPEN_IP_SAP_OPTIONS;
	DP(("open_ip_sap: opt = %x\n", (int)osb.sap_options));
	return(fv_open_sap(fv, &osb));
}

/*
 * close sap:
 */
static int
fv_close_sap(struct fv_info *fv, u_short station_id)
{
	int error;
	FVIO *io = fv->FVIO;
	FVMEM *mem = fv->fv_mem;

	if ((error = fv_getscb(fv)) == 0) {
		mem->tr_scb.scb_parm1 = station_id;
		mem->tr_scb.scb_cmd = TR_CMD_CLOSE_SAP;
		io->sifcmd_stat = TR_CMD_INT_ADAPT | TR_CMD_EXECUTE | 
		        	TR_CMD_SCB_REQUEST | TR_STAT_INTR;
	}
	return(error);
}

#ifdef OLDKICK
/*
 * kick_promisc:
 */
static int
kick_promisc(struct fv_info *fv)
{
	int s, error;
	u_short newopt;

	if ((fv->flags&(TR_ONCHIPLLC|TR_PROMISC)) == 0)
		return(0);
	if ((error = fv_getscb(fv)) == 0) {
		FVIO *io = fv->FVIO;
		FVMEM *mem = fv->fv_mem;

		newopt = fv->fv_openop;
		if (!(fv->flags&TR_ONCHIPLLC))
			newopt |= TR_COPY_ALL_MAC_FRAMES;
		if (fv->flags&TR_PROMISC)
			newopt |= TR_COPY_ALL_NON_MAC;
		DP(("fv%d: kick promisc: opt = %x\n",
				fv->fv_unit,newopt));
		mem->tr_scb.scb_parm1 = newopt;
		mem->tr_scb.scb_cmd = TR_CMD_MOD_OPEN_PARMS;
		io->sifcmd_stat = TR_CMD_INT_ADAPT | TR_CMD_EXECUTE | 
		        	TR_CMD_SCB_REQUEST | TR_STAT_INTR;
	}
	return(error);
}
#endif

/*
 * open station:
 */
static int
fv_open_station(struct fv_info *fv, struct tr_open_station_block *ostn)
{
	caddr_t trg = (caddr_t)&fv->fv_mem->open_station_block;
	VMEOUT((caddr_t)ostn, trg, sizeof(*ostn));
	return(fvIssueCmd(fv,TR_CMD_OPEN_STATION,BDMEM(open_station_block,u_int)));
}

/*
 * close station:
 */
static int
fv_close_station(struct fv_info	*fv, u_short station_id)
{
	int error;
	FVIO *io = fv->FVIO;
	FVMEM *mem = fv->fv_mem;

	if ((error = fv_getscb(fv)) == 0) {
		mem->tr_scb.scb_cmd = TR_CMD_CLOSE_STATION;
		mem->tr_scb.scb_parm1 = station_id;
		io->sifcmd_stat = TR_CMD_INT_ADAPT | TR_CMD_EXECUTE | 
		        	TR_CMD_SCB_REQUEST | TR_STAT_INTR;
	}
	return(error);
}

/*
 * Set address.
 */
static int
fv_setaddr(struct fv_info *fv, u_short *sp)
{
	int error;
	FVIO *io = fv->FVIO;
	FVMEM *mem = fv->fv_mem;

	if ((error = fv_getscb(fv)) == 0) {
		if (sp == (u_short*)&fv->tr_fcn_addr) {
			mem->tr_scb.scb_cmd = TR_CMD_SET_FUNCT;
#if (DBG_LVL >= DBG_LVL_DRV)
printf ("fv_setaddr(): Setting functional address C000-%x-%x\n", sp[0], sp[1]);
#endif
		} else if (sp == (u_short*)&fv->tr_grp_addr) {
#if (DBG_LVL >= DBG_LVL_DRV)
printf ("fv_setaddr(): Setting group address C000-%x-%x\n", sp[0], sp[1]);
#endif
			mem->tr_scb.scb_cmd = TR_CMD_SET_GROUP;
		} else {
#if (DBG_LVL >= DBG_LVL_DRV)
printf ("fv_setaddr(): Invalid pointer");
#endif
			return(EINVAL);
		}
		mem->tr_scb.scb_parm1 = sp[0];
		mem->tr_scb.scb_parm2 = sp[1];
		io->sifcmd_stat = TR_CMD_INT_ADAPT | TR_CMD_EXECUTE | 
		        	TR_CMD_SCB_REQUEST | TR_STAT_INTR;
	}
	return(error);
}

/*
 * connect station:
 */
static int
fv_connect_station(struct fv_info *fv, struct tr_connect_station_block *csb)
{
	VMEOUT((caddr_t)csb, (caddr_t)&fv->fv_mem->conn_stn_block, sizeof(*csb));
	return(fvIssueCmd(fv,TR_CMD_CONNECT_STATION,BDMEM(conn_stn_block,u_int)));
}

/*
 * llc reset
 */
static int
tr_llc_reset(struct fv_info *fv, u_short station_id)
{
	FVIO *io = fv->FVIO;
	int error = ENETDOWN;
	FVMEM *mem = fv->fv_mem;

	if ((fv->fv_state == FV_STATE_OK) && (error = fv_getscb(fv)) == 0) {
		mem->tr_scb.scb_parm1 = station_id;
		mem->tr_scb.scb_cmd = TR_CMD_LLC_RESET;
		io->sifcmd_stat = TR_CMD_INT_ADAPT | TR_CMD_EXECUTE | 
					TR_CMD_SCB_REQUEST | TR_STAT_INTR;
	}
	return(error);
}

/*
 * transmit I-frame
 */
fv_xmit_iframe(struct fv_info *fv, TR_XMIT_PARMS *xp, IFRAMES *ifrp)
{
	int newlast;
	int error = 0;
	int bumpcorel = 0;
	FVIO *io = fv->FVIO;
	FVMEM *mem = fv->fv_mem;
	LCB *lcb = tr_find_WR_q(&fv->fv_if, xp->station_id);

	DP(("fv%d: xmit_iframe, sid = %x, mblk = %x, lcb = %x\n",
			fv->fv_unit,xp->station_id,xp->xmit_data,lcb));
	if (lcb == 0) {
		IWMSG(("fv%d: xmit_iframe: No LCB for sid=%x\n",
			fv->fv_unit,xp->station_id));
		error = EIO; goto xif_ret;
	}
#ifdef QDBG
	if (fvifx.lcb != (u_long)lcb) {
		fvifx.lcb = (u_long)lcb;
	}
#endif
	if (lcb->ifr_state == IFR_STATE_WAIT) {
		/* C16 issued HOLD, so we can not even issue req. */
		IWMSG(("Iframe REQ not issued due to C16 busy\n"));
		error = ENOBUFS; goto xif_ret;
	}

	/* compensate slow C16 response */
	SLOWDOWN;

	/* look for a place to store the iframe information in the LCB */
	if (ifrp == 0) {
		/* It is brand new iframe */
		bumpcorel = 1;
		if (lcb->ifr_cnt >= (NIFRAMES-1)) {
			/* full , but left 1 as DMZ */
			IWMSG(("Xiframe Q is full\n"));
			error = ENOBUFS; goto xif_ret;
		}
		if ((newlast = lcb->ifr_last + 1) >= NIFRAMES)
			newlast = 0;

		/* save IFRAME info */
		ifrp = &lcb->iframes[lcb->ifr_last];
		if (ifrp->state != TR_IFRM_NULL) {
			printf("invalid new state = %d\n",(u_int)ifrp->state);
		}

		ifrp->correlator = (lcb->ifr_corel|0x1);
		bcopy((char*)xp,(char*)&ifrp->xmit_parms,sizeof(*xp));

		lcb->ifr_cnt += 1;
		lcb->ifr_last = newlast;

		if (lcb->ifr_pend != 0) {
			IWMSG(("Holding Iframe ec=%x\n", lcb->ifr_corel));
			ifrp->state = TR_IFRM_PENDING;
			QDBGUP(fvifx.pend,1);
			goto xif_ret;
		}
	} else {
		/* It is retry of held iframe */
		if (ifrp->state != TR_IFRM_PENDING) {
			printf("invalid hold state = %d\n",(u_int)ifrp->state);
		}
	}

	if ((ifrp->correlator&0x1) == 0) {
		IWMSG(("corel valid already=%x", (u_int)ifrp->correlator));
		goto xif_ret;
	}

	if (error = fv_getscb(fv)) {
		IWMSG(("Iframe(%x) REQ not issued due to NO SCB\n",
				ifrp->correlator));
		goto xif_ret;
	}
#ifdef IWAITDBG
	if (babble) {
		printf("Iframe request to board\n");
		babble--;
	}
#endif
	QDBGUP(fvifx.wcorel,1);
	ifrp->state = TR_IFRM_WAIT_COREL;
	mem->tr_scb.scb_parm1 = xp->station_id;
	mem->tr_scb.scb_parm2 = 0;
	mem->tr_scb.scb_cmd = TR_CMD_XMIT_IFRAME;
	io->sifcmd_stat = TR_CMD_INT_ADAPT | TR_CMD_EXECUTE | 
		        TR_CMD_SCB_REQUEST | TR_STAT_INTR;
	lcb->ifr_pend = 1;

xif_ret:
	if ((bumpcorel != 0) && (error == 0) && (lcb != 0)) {
		lcb->ifr_corel += 2;
		lcb->ifr_corel &= 0xfe;
	}
	return(error);
}

/*
 * issue receive request
 */
static int
fv_receive(struct fv_info *fv)
{
	DELAY(10000); /* delay 10 msec */
	return(fvIssueCmd(fv, TR_CMD_RECEIVE, BDMEM(fv_rlist[0],u_int)));
}

/*
 * initiate a transmit request
 */
static int
fv_transmit(struct fv_info *fv)
{
	fv->xmitlist_free->xmit_cstat = 0;
	return(fvIssueCmd(fv,TR_CMD_TRANSMIT,BDMEM(fv_xlist[0],u_int))); 
}

static void
fv_read_errlog(struct fv_info *fv)
{
	u_int addr;
	FVIO *io = fv->FVIO;
	FVMEM *mem = fv->fv_mem;
	int error = fv_getscb(fv);

	if (error != 0) return;
	mem->tr_scb.scb_cmd = TR_CMD_READ_ERRLOG;
	addr = BDMEM(tr_error_log, u_int);
	BDINT(mem->tr_scb.scb_parm1, addr);
	io->sifcmd_stat = TR_CMD_INT_ADAPT | TR_CMD_EXECUTE |
		        	TR_CMD_SCB_REQUEST | TR_STAT_INTR;
}

/*
 *  Process an ioctl request.
 */
static int
if_fvioctl(struct ifnet *ifp, int cmd, caddr_t data)
{
	int i;
	int error = 0;
	int s = splimp();
	TR_FCNADDR *fa = (TR_FCNADDR *)data;
	struct fv_info *fv = &fv_info[ifp->if_unit];

	ASSERT(&fv->fv_ac == (struct arpcom*)ifp);
	ASSERT(IFNET_ISLOCKED(ifp));
	DP(("fv%d: if_fvioctl cmd=0x%x fv_state=0x%x.\n",
	    ifp->if_unit, cmd, fv->fv_state));
	switch (cmd) {
	case SIOCSIFADDR: {
		struct sockaddr *addr = _IFADDR_SA(data);
		int naddrset =	fv->naddrset;

		switch (addr->sa_family) {
	    	case AF_INET:
			/*
			 * Set IPaddr no matter what, so that null ipaddr
			 * and null netmask can be avoided.
			 */
			fv->fv_ac.ac_ipaddr = ((struct sockaddr_in*)addr)->sin_addr;
			((struct arpcom*)ifp)->ac_ipaddr
				= ((struct sockaddr_in*)addr)->sin_addr;

			fv->naddrset = 1;
			if (naddrset) {
				/* force hard reset except first time */
				fvreset(fv, 1);
#if 0
			} else if ((fv->flags&TR_EDTINIT) == 0) {
				if ((error = if_fvinit(ifp->if_unit)) != 0)
					break;
#endif
			}
			if (fv->fv_state == FV_STATE_OK) {
				fv->fv_if.if_flags |= (IFF_RUNNING|IFF_UP);
			} else {
				if (fv->fv_state == FV_STATE_SICK)
					fvreset(fv, 1);
				else if ((fv->fv_state == FV_STATE_CLOSE) ||
					 (fv->fv_state == FV_STATE_INIT))
					fvstart2(fv);
				if ((error = if_fvinit(ifp->if_unit)) != 0)
					break;
			}
			arpwhohas((struct arpcom *)ifp, 
				  &((struct sockaddr_in*)addr)->sin_addr);
			break;

		case AF_RAW:
			bcopy(addr->sa_data, fv->fv_enaddr,
		      		sizeof(fv->fv_enaddr));
			DP(("fv%d: tokenring address %s\n",
				fv->fv_unit, ether_sprintf(fv->fv_enaddr)));
			if (showconfig) {
				printf("fv%d: tokenring address %s\n",
				    fv->fv_unit, ether_sprintf(fv->fv_enaddr));
			}
			fv->addrset = 1;
			ifp->if_flags &= ~(IFF_RUNNING | IFF_UP);
			if (fv->fv_state == FV_STATE_OK) {
				if (fv_close(fv, 1))
					fvreset(fv,1);
			} else if (fv->fv_state == FV_STATE_SICK) {
				fvreset(fv,1);
			} else if ((fv->fv_state == FV_STATE_CLOSE) ||
				   (fv->fv_state == FV_STATE_INIT)) {
				fvstart2(fv);
			}
			if ((error = if_fvinit(ifp->if_unit)) != 0)
				break;
			arpwhohas((struct arpcom*)ifp,
				&((struct arpcom *)ifp)->ac_ipaddr);
			break;
		}
	} break;

	case SIOCSIFFLAGS: {
		int doreset = 0;
		int oflag = ifp->if_flags;
		struct ifreq *ifr = (struct ifreq *)data;

		ifp->if_flags = ifr->ifr_flags;
DP(("fv%d: SIOCSIFFLAGS: %x -> %x\n",fv->fv_unit, oflag, ifp->if_flags));

#ifdef FV_CAF
  		if ((ifp->if_flags & IFF_PROMISC) && !(fv->flags&TR_PROMISC)){
			fv->flags |= TR_PROMISC;
			fv->flags &= ~TR_ONCHIPLLC;
			doreset = 1;
		}else if (!(ifp->if_flags&IFF_PROMISC)&&(fv->flags&TR_PROMISC)){
			fv->flags &= ~TR_PROMISC;
#ifndef HOSTLLC
			fv->flags |= TR_ONCHIPLLC;
#endif
			doreset = 1;
		}
#if (DBG_LVL >= DBG_LVL_DRV)
		else if (ifp->if_flags & IFF_DEBUG) {
			fv_dumprbuf(fv);
			fv->FVIO->sifcmd_stat=TR_CMD_INT_ADAPT|TR_CMD_RCV_VALID|TR_STAT_INTR;
		}
#endif
		if (doreset) {
			fv->fv_if.if_flags |= IFF_UP;
			fv->fv_if.if_flags &= ~IFF_RUNNING;
			oflag &= ~IFF_UP;
		}
#else
  		if ((ifp->if_flags & IFF_PROMISC) && !(fv->flags&TR_PROMISC)){
			ifp->if_flags &= ~IFF_PROMISC;
			error = EIO;	
			break;
		}else if (!(ifp->if_flags&IFF_PROMISC)&&(fv->flags&TR_PROMISC)){
			ifp->if_flags &= ~IFF_PROMISC;
			error = EIO;
			break;
		}
#endif
  		if (!(ifp->if_flags & IFF_UP) && (oflag&IFF_UP)) {
			if (doreset) {
				fvreset(fv, 0);
			} else if (fv_close(fv, 0)) {
				error = EIO; break;
			}
			fv->fv_if.if_flags &= ~(IFF_RUNNING|IFF_UP);
			if_down(ifp);
		} else if ((ifp->if_flags & IFF_UP) && !(oflag & IFF_UP)) {
			if (doreset || fv->fv_state == FV_STATE_SICK)
				fvreset(fv, 1);
			else if ((fv->fv_state == FV_STATE_CLOSE) ||
				 (fv->fv_state == FV_STATE_INIT))
				fvstart2(fv);
			else if (fv->fv_state >= FV_STATE_OK)
				if (fv_close(fv, 1)) {
					error = EIO; break;
				}
		 	error = if_fvinit(ifp->if_unit);
			if (error) {
				fv->flags &= ~TR_PROMISC;
#ifndef HOSTLLC
				fv->flags |= TR_ONCHIPLLC;
#endif
				ifp->if_flags &= ~IFF_PROMISC;
				fv->fv_state = FV_STATE_SICK;
				break;
			}
			if (ifp->in_ifaddr != 0) {
				arpwhohas((struct arpcom*)ifp,
					&((struct arpcom *)ifp)->ac_ipaddr);
			}
		}
	} break;

	case SIOCADDMULTI: {
		struct sockaddr *addr = (struct sockaddr *)data;

		if (addr->sa_family == AF_INET) {
			/*
			 * Per RFC 1469, all IP mcast addresses
			 * map to C0-00-00-04-00-00. So turn on
			 * that bit in the functional address.
			 */
			fv->tr_fcn_addr.a[0] |= 4;
			error = fv_setaddr(fv, (u_short*)&fv->tr_fcn_addr);
		} else {
			/* Verify that the address begins with C0-00 */
			if ((addr->sa_data[0] != 0xC0) ||
			    (addr->sa_data[1] != 0)) {
				error = EINVAL;
			} else if (addr->sa_data[2] & 0x80) {
				/* It's a group address */
				bcopy(&addr->sa_data[2],
				      (caddr_t)&fv->tr_grp_addr,
					sizeof(fv->tr_grp_addr));
				error = fv_setaddr(fv, (u_short*)&fv->tr_grp_addr);
			} else {
				/* it's a functional address, turn bits on */
				fv->tr_fcn_addr.a[0] |= 
					*(u_short *)&addr->sa_data[2];
				fv->tr_fcn_addr.a[1] |= 
					*(u_short *)&addr->sa_data[4];
				error = fv_setaddr(fv, (u_short*)&fv->tr_fcn_addr);
			}
		}
	} break;

	case SIOCDELMULTI: {
		struct sockaddr *addr = (struct sockaddr *)data;
		if (addr->sa_family == AF_INET) {
			/* Turn off the IP bit, but there is a danger
			 * that some other user may also have requested
			 * this functional address bit.
			 */
			fv->tr_fcn_addr.a[0] &= 0xFFBF;
			error = fv_setaddr(fv, (u_short*)&fv->tr_fcn_addr);
		} else {
			/* Verify that the address begins with C0-00 */
			if ((addr->sa_data[0] != 0xC0) ||
			    (addr->sa_data[1] != 0)) {
				error = EINVAL;
			} else if (addr->sa_data[2] & 0x80) {
				/* It's a group address */
				/* But is it our current group address? */
				if (bcmp ((caddr_t) &addr->sa_data[2],
					  (caddr_t) &fv->tr_grp_addr,
					  sizeof(fv->tr_grp_addr))) {
					error = EINVAL;
				} else {
					bzero((caddr_t)&fv->tr_grp_addr,
					      sizeof(fv->tr_grp_addr));
					error = fv_setaddr(fv, (u_short*)&fv->tr_grp_addr);
				}
			} else {
				/* it's a functional address, turn bits off */
				fv->tr_fcn_addr.a[0] &= 
				    ~(*(u_short *)&addr->sa_data[2]);
				fv->tr_fcn_addr.a[1] &= 
				    ~(*(u_short *)&addr->sa_data[4]);
				error = fv_setaddr(fv, (u_short*)&fv->tr_fcn_addr);
			}
		}
	} break;

	case SIOC_TR_GETMULTI:
		*fa = fv->tr_grp_addr;
		break;

        case SIOC_TR_ADDMULTI:
	DP(("fv%d: GA_ADD %x %x\n",fv->fv_unit,(int)fa->a[0],(int)fa->a[1]));
		for (i = 0; i < (sizeof(*fa)/sizeof(short)); i++)
			fv->tr_grp_addr.a[i] |= fa->a[i];
		error = fv_setaddr(fv, (u_short*)&fv->tr_grp_addr);
		break;

	case SIOC_TR_DELMULTI:
	DP(("fv%d: GA_DEL %x %x\n",fv->fv_unit,(int)fa->a[0],(int)fa->a[1]));
		for (i = 0; i < (sizeof(*fa)/sizeof(short)); i++)
			fv->tr_grp_addr.a[i] &= ~(fa->a[i]);
		error = fv_setaddr(fv, (u_short*)&fv->tr_grp_addr);
		break;

	case SIOC_TR_GETFUNC:
		*fa = fv->tr_fcn_addr;
		break;

	case SIOC_TR_ADDFUNC:
	DP(("fv%d: FA_ADD %x %x\n",fv->fv_unit,(int)fa->a[0],(int)fa->a[1]));
		for (i = 0; i < (sizeof(*fa)/sizeof(short)); i++)
			fv->tr_fcn_addr.a[i] |= fa->a[i];
		error = fv_setaddr(fv, (u_short*)&fv->tr_fcn_addr);
		break;

	case SIOC_TR_DELFUNC:
	DP(("fv%d: FA_DEL %x %x\n",fv->fv_unit,(int)fa->a[0],(int)fa->a[1]));
		for (i = 0; i < (sizeof(*fa)/sizeof(short)); i++)
			fv->tr_fcn_addr.a[i] &= ~(fa->a[i]);
		error = fv_setaddr(fv, (u_short*)&fv->tr_fcn_addr);
		break;

	case SIOCADDSNOOP:
	case SIOCDELSNOOP:
		/* Force promisc always */
		error = EINVAL;
		break;

	case SIOC_TR_GETCONF: {
		TR_CONFIG trc;
		FVIO *io = fv->FVIO;
		TR_SIOC *sioc = (TR_SIOC*)data;
		int len = MIN(sizeof(trc), sioc->len);

		bcopy(fv->fv_enaddr,trc.caddr, TR_MAC_ADDR_SIZE);
		bcopy(fv->fv_bia, trc.bia, TR_MAC_ADDR_SIZE);
		bcopy(fv->mcl, trc.mcl, sizeof(trc.mcl));
		bcopy(fv->pid, trc.pid, sizeof(trc.pid));
		bcopy(fv->sid, trc.sid, sizeof(trc.sid));
#define	FV_VERS ((((VERS_Y-92)*13+VERS_M)*32+VERS_D)*24+VERS_H)*60+VERS_MM
		trc.vers = FV_VERS;
		trc.speed = (fv->flags&TR_16_MBIT) ? 0 : 1;
		fv_fetbdm(io,fv->ia.parmp,(u_short*)&trc.phys_drop_hi,
					sizeof(TMS_RA_PARMS));

		if (copyout((caddr_t)&trc, (caddr_t)sioc->tr_ptr_u.conf, len))
			error = EFAULT;
		} break;

	case SIOC_TR_GETST: {
		TR_SIOC *sioc = (TR_SIOC*)data;
		TR_STATUS *trs = &fv->fv_statlog;
		int len = MIN(sizeof(*trs), sioc->len);

		/* reuse rcv stats */
		trs->r_callouts = fvints.recv;
		trs->frame_ct = fv->fv_if.if_ipackets;
		trs->frm_cpy_ct = fv->fv_if.if_ipackets;
		trs->misfrm = fv->fv_if.if_ierrors;
		trs->byte_ct = fv->fv_if.if_ibytes;
/*
		trs->e
		trs->a
		trs->c
*/
		/* reuse xmit stats */
		trs->x_callouts = fvints.xmit;
		trs->xmit_frm_ct = fv->fv_if.if_opackets;
		trs->x_cpy_ct = fv->fv_if.if_opackets;
		trs->xmtabt = fv->fv_if.if_oerrors;
		trs->x_byte_ct = fv->fv_if.if_obytes;

		if (copyout((caddr_t)trs, (caddr_t)sioc->tr_ptr_u.st, len))
			error = EFAULT;
		}

		/* one sec behind */
		fv_read_errlog(fv);
		break;

	case SIOC_TR_ARM: {
		TR_SIOC *sioc = (TR_SIOC*)data;

		if (!_CAP_ABLE(CAP_NETWORK_MGT)) {
			error = EPERM;
			break;
		}
		if (0 == fv->alarm_mbuf) {
			fv->alarm_mbuf = m_get(M_WAIT, MT_DATA);
			if (0 == fv->alarm_mbuf) {
				error = ENOBUFS;
				break;
			}
		}
		sioc->tr_ptr_u.alarm = fv->alarm;
		fv->alarm = 0;
		} break;

	}
	splx(s);
	return(error);
}


/*
 * Process an interrupt from fv1600 board.
 */
int
if_fvintr(int unit)
{
	int cmdsts;
	FVIO *io; SSB ssb;
	FVMEM *mem; TR_ICB icb;
	int s = splimp();
	int found = 0;
	struct fv_info *fv = &fv_info[unit];
	ASSERT(unit >= 0 && unit < FV_MAXBD);

	if ((io = fv->FVIO) == 0) {
		printf("fv%d: early interrupt\n", unit);
		goto fvintr_ret;
	}
	IFNET_LOCKNOSPL(&fv->fv_if);
	QDBGUP(fvints.tot,1);
	mem = fv->fv_mem;
iloop:
	/* get the type of interrupt */
	cmdsts = io->sifcmd_stat;
	if ((cmdsts&TR_STAT_INTR) == 0) {
		IFNET_UNLOCKNOSPL(&fv->fv_if);
		goto fvintr_ret;
	}
	found++;
	cmdsts &= ~TR_STAT_INTR;
	cmdsts |= TR_CMD_INT_ADAPT|TR_CMD_SSB_CLEAR;

	switch(cmdsts&TR_STAT_INT_CODE) {
	case TR_INT_RING_STAT:
		VMEIN((caddr_t)&mem->tr_ssb, &ssb, sizeof(SSB));
		io->sifcmd_stat = cmdsts;
		fv_process_ring_status(fv,&ssb);
		break;

	case TR_INT_LLC_STAT:
		fv_fetbdm(io,TR_ICB_ADDR,(u_short*)&icb,sizeof(icb));
		io->sifcmd_stat = cmdsts;
		fv_process_llc_status(fv, &icb);
		break;

	case TR_INT_COMMAND_STAT:
		VMEIN((caddr_t)&mem->tr_ssb, &ssb, sizeof(SSB));
		io->sifcmd_stat = cmdsts;
		tr_process_cmd_status(fv, &ssb);
		break;

	case TR_INT_RCV_STAT:
		VMEIN((caddr_t)&mem->tr_ssb, &ssb, sizeof(SSB));
		io->sifcmd_stat = cmdsts;
		tr_process_rcv_status(fv, &ssb);
		QDBGUP(fvints.recv,1);
		goto iloop;

	case TR_INT_XMIT_STAT:
		VMEIN((caddr_t)&mem->tr_ssb, &ssb, sizeof(SSB));
		io->sifcmd_stat = cmdsts;
		tr_process_xmit_status(fv,&ssb);
		QDBGUP(fvints.xmit,1);
		goto iloop;

	case TR_INT_RCV_PENDING:
		/* fetch icb only as much needed */
#if DBG_LVL >= DBG_LVL_LLI
	fv_fetbdm(io,TR_ICB_ADDR,(u_short*)&icb,sizeof(icb));
	if ((icb.frame_type!=TR_MAC_FRAME) && (icb.frame_type!=TR_UI_FRAME))
		printf("fv%d: recv_pending %d bytes, ft=%x\n",
		    fv->fv_unit,icb.frame_len,(u_int)icb.frame_type);
#else
		fv_fetbdm(io,TR_ICB_ADDR+6,(u_short*)&icb.frame_len,2);
#endif
		io->sifcmd_stat = cmdsts;
		fv_process_rcv_pending(fv);
		break;

	case TR_INT_ADAP_CHECK: {
		TR_ADAPTER_CHECK_BLOCK adc;
		fv_fetbdm(io,TR_ADAPTER_CHECK_BLOCK_ADDR,
					(u_short*)&adc,sizeof(adc));
		io->sifcmd_stat = cmdsts;
		printf("fv%d: died cmd=%x,rc=%x\n",
				unit,(int)ssb.ssb_command,(int)adc.adc_status);
		fv->fv_state = FV_STATE_SICK;
		}
		QDBGUP(fvints.buf,1);
		IFNET_UNLOCKNOSPL(&fv->fv_if);
		goto fvintr_ret;

	case TR_INT_SCB_CLEAR:
		DP(("fv%d: SCB_CLEAR interrupt recvd\n", fv->fv_unit));
		io->sifcmd_stat = cmdsts;
		break;
	case TR_INT_TIMER:
		fv_fetbdm(io,TR_ICB_ADDR,(u_short*)&icb,sizeof(icb));
		io->sifcmd_stat = cmdsts;
		DP(("fv%d: TIMER interrupt recvd\n", fv->fv_unit));
		break;
	default:
		io->sifcmd_stat = cmdsts;
		printf("fv%d: spurious interrupt = %x\n",fv->fv_unit,cmdsts);
		break;
	}
	QDBGUP(fvints.buf,1);
	goto iloop;

fvintr_ret:
#ifdef QDBG
	if (!found) {
		QDBGUP(fvints.stray,1);
	}
#endif
	splx(s);
	return(found);
}

/*
 * Process a ring status interrupt
 */
static void
fv_process_ring_status(struct fv_info *fv, register SSB *ssb)
{
	register TR_STATUS *ct = &fv->fv_statlog;
	register u_int stat = (u_int)ssb->ssb_stat;

/*	DP(("fv%d: ring status = %x\n", fv->fv_unit, ssb->ssb_stat)); */
	if (stat & TR_SIGNAL_LOSS)	ct->signal_loss++;
	if (stat & TR_HARD_ERROR) 	ct->hard_error++;	/* bcn */
	if (stat & TR_SOFT_ERROR)	ct->soft_error++;	/* err report */
	if (stat & TR_XMIT_BEACON)	ct->beacons++;		/* x bcn */
	if (stat & TR_LOBE_WIRE_FAULT)	ct->lobe_wire_fault++;
	if (stat & TR_AUTO_REMOVAL_ERR)	ct->auto_removal_err++;
	if (stat & TR_REMOVE_RCV)	ct->remove_rcv++;
	if (stat & TR_RING_RECOVERY)	ct->ring_recovery++;	/* clm */
	if (stat & TR_COUNTER_OVFL)	fv_read_errlog(fv);
}

/*
 * Process a command status interrupt.
 */
static void
tr_process_cmd_status(struct fv_info *fv, SSB *ssb)
{
	LLI_CB *cbp;
	struct mbuf *m0;
	FVMEM *mem = fv->fv_mem;
	u_int cmd = ssb->ssb_command;

/*	printf("cmd_status: fv=%x, mem=%x, cmd=%x\n",fv,mem,(u_short)cmd); */
	switch (cmd) {
	    case TR_CMD_READ_ADAPTER:
		if (ssb->ssb_stat != TR_READ_ADAPTER_OK) {
		DP(("fv%d: cannot read MAC address from Token-Ring board\n", fv->fv_unit));
		}
		break;
		    
	    case TR_SSB_COMMAND_REJ:
		DP(("fv%d: cmd %x failed, status = %x\n", fv->fv_unit, ssb->ssb_parm1, ssb->ssb_parm0));
		break;

	    case TR_CMD_OPEN:
		ASSERT(fv->fv_state == FV_STATE_OPEN);
		ASSERT(fv->cmd_Flags[cmd] & CMD_BUSY);
		fv->cmd_Flags[cmd] &= ~CMD_BUSY;
		fv->cmd_Status[cmd] = ssb->ssb_stat;
		fvstart3(fv);
		break;

	    case TR_CMD_CLOSE:
		if (ssb->ssb_stat == TR_CLOSE_OK) {
			fv->cmd_Status[cmd] = 0;
			DP(("fv%d: close completed ok\n", fv->fv_unit));
		} else {
			fv->cmd_Status[cmd] = ssb->ssb_stat;
			DP(("fv%d: close faild = %x\n", ssb->ssb_stat));
		}
		fv->cmd_Flags[cmd] &= ~CMD_BUSY;
		wakeup((caddr_t)&fv->cmd_Status[cmd]);
		break;

	    case TR_CMD_OPEN_SAP:
		if (fv->fv_state == FV_STATE_OPENSAP) {
			ASSERT(fv->cmd_Flags[cmd]&CMD_BUSY);
			fv->cmd_Flags[cmd] &= ~CMD_BUSY;
			fv->cmd_Status[cmd] = ssb->ssb_stat;
			fv->ip_sid = ssb->ssb_parm1;
			fvstart4(fv);
			return;
		}

		if (ssb->ssb_stat != 0)
			DP(("TRD: OPEN_SAP(SNA) failed, status = %x, stn_id = %x\n", ssb->ssb_stat, ssb->ssb_stn_id));
		else
			DP(("TRD: OPEN_SAP(SNA) succeeded, stn_id = %x\n", ssb->ssb_stn_id));

		m0 = m_vget(M_DONTWAIT,(sizeof(*cbp)+sizeof(*ssb)),MT_DATA);
		if (m0 == 0) {
			printf("fv%d: no mbuf for OPen SAP\n",fv->fv_unit);
			break;
		}

		cbp = mtod(m0, LLI_CB*);
		cbp->port = fv->fv_unit;
		cbp->command = LLI_CMD_RSP;
		cbp->param_blk = (cbp+1);
		bcopy((char*)ssb, (char*)cbp->param_blk, sizeof(*ssb));
		m0->m_len = (sizeof(*cbp)+sizeof(*ssb));
		fv_lli(m0);
		break;

	    case TR_CMD_LLC_RESET:
		DP(("fv%d: LLC RESET complete, status = %x\n", fv->fv_unit, ssb->ssb_stat));
		break;

	    case TR_CMD_OPEN_STATION:
	    case TR_CMD_CLOSE_SAP:
	    case TR_CMD_CLOSE_STATION:
	    case TR_CMD_CONNECT_STATION:

		DP(("fv%d: cmd = %x,status = %x, sap = %x: being sent up to SNA\n", fv->fv_unit, ssb->ssb_command, ssb->ssb_stat, ssb->ssb_parm1));
		/* 
		 * Station transactions and LLC_RESET are only issued
		 * by SNA; so don't even check for IP protocol stack.
		 * Just default to SNA.
		 */
		m0 = m_vget(M_DONTWAIT,(sizeof(*cbp)+sizeof(*ssb)),MT_DATA);
		if (m0 == 0) {
			printf("fv%d: no mbuf for OPEN/CLOSE/CONNECT stat\n",
					fv->fv_unit);
			break;
		}

		cbp = mtod(m0, LLI_CB*);
		cbp->port = fv->fv_unit;
		cbp->command = LLI_CMD_RSP;
		cbp->param_blk = (cbp+1);
		bcopy((char*)ssb, (char*)cbp->param_blk, sizeof(*ssb));
		m0->m_len = (sizeof(*cbp)+sizeof(*ssb));
		fv_lli(m0);

		break;

	    case TR_CMD_XMIT_IFRAME: {
		__psunsigned_t *bp;
		m0 = m_vget(M_DONTWAIT,(sizeof(int)+sizeof(*ssb)),MT_DATA);
		if (!m0) {
			printf("fv%d: no mbuf for XMIT_IFRAME stat\n",
						fv->fv_unit);
			break;
		}
		bp = mtod(m0, __psunsigned_t*);
		bp[0] = (__psunsigned_t)fv;
		bcopy((char*)ssb, (char*)(&bp[1]), sizeof(*ssb));
		m0->m_len = sizeof(__psunsigned_t)+sizeof(*ssb);
#ifdef IWAITDBG
		if (babble) {
			printf("got ifr intr(%x)\n",(u_int)ssb->ssb_stat);
			babble--;
		}
#endif
		fv_ifr_intr(m0);
		}
		break;

	    case TR_CMD_READ_ERRLOG: {
		/* Just keep accumulating.
		 * After each read err log, board resets counters.
		 */
		TR_STATUS *trs = &fv->fv_statlog;

		if (ssb->ssb_stat != TR_READ_ERRLOG_OK) {
		    printf("fv%d: read error log from failed\n", fv->fv_unit);
		    break;
		}

#define RFCNT(a) trs->a += (u_int)mem->tr_error_log.a
		RFCNT(line_err);
		RFCNT(burst_err);
		RFCNT(ari_fci_err);
		RFCNT(lost_frame_err);
		RFCNT(rcv_cong_err);
		RFCNT(frame_copied_err);
		RFCNT(token_err);
		RFCNT(dma_bus_errs);
		RFCNT(dma_parity_errs);
#undef RFCNT
		} break;

	    default:
		break;
	}
}

/*
 * Process a receive status interrupt
 */
static int
tr_process_rcv_status(struct fv_info *fv, SSB *ssb)
{
	register volatile struct tr_rcv_list *rcvlist, *last;
	register int flen, yield_len = 0;
	register FVMEM *mem = fv->fv_mem;
	int fpc = 0;

	if (ssb->ssb_stat & TR_RCV_SUSPENDED) {
		XDP(("rcv_status: SUSPENDED!!!\n"));
		/* rearm recv */
		fv_setrbuf(fv);
		(void)fv_receive(fv);
		return(0);
	}

	if (!(ssb->ssb_stat & TR_RCV_FRAME_COMPLETE)) {
		/* ignore it for now */
		DP(("rcv_status: FRAME INCOMPLETE!!!\n"));
		return(0);
	}

	/* get first and last receive lists */
	last = LISTP(ssb, volatile struct tr_rcv_list *);
	CHKRL(last);
	for (rcvlist = fv->rcvlist_first;;) {
		if ((rcvlist->rcv_cstat & TR_RCVL_VALID) ||
		    !(rcvlist->rcv_cstat & TR_RCVL_START_FRAME)) {
			/* ignore it for now */
/*			DP(("fv%d: invalid rcvlist\n", fv->fv_unit)); */
			break;
		}
		if (!(rcvlist->rcv_cstat & TR_RCVL_FRAME_COMPLETE)) {
			fv->fv_statlog.rcv_incmplt++;
			DP(("fv%d: incomplete frame\n", fv->fv_unit));
			break;
		}
	
		fpc++;
		flen = fv_recv(fv, rcvlist);
		QDBGHW(flen,fv->fv_statlog.r_maxsize);
		yield_len += flen;
		rcvlist = fv_get_rcvlist(fv, flen, 0);
		fv->FVIO->sifcmd_stat=TR_CMD_INT_ADAPT|TR_CMD_RCV_VALID|TR_STAT_INTR;
		if (last==(volatile struct tr_rcv_list*)TR_PREV_RCVLIST(mem,rcvlist))
			break;
	}
	fv->rcvlist_first = rcvlist;

	if (yield_len > 8*1024) {
		yield_len = 0;
		vme_yield(fv->fv_brl, fv->fv_vme_adapter);
	}
	QDBGHW(fpc,fv->fv_statlog.r_maxfpc);
	return(0);
}

static void
fv_lli(struct mbuf *m0)
{
	int s1, s;
	mblk_t *s0;
	LLI_CB *cbp;

	ASSERT(m0->m_next == 0);
	if (m0 == 0)
		return;

	/* XXX: llc ctl frame size < 4K */
	s1 = spl1();
	s = splimp();
	if ((s0 = allocb(m0->m_len,BPRI_MED)) == 0) {
		printf("fv_lli: no mblk size=%d\n",m0->m_len);
		goto lliret_1;
	}

	bcopy(mtod(m0, char*), s0->b_wptr, m0->m_len);
	s0->b_datap->db_type = M_PROTO;
	s0->b_wptr += m0->m_len;
	cbp = (LLI_CB*)s0->b_rptr;
	cbp->param_blk = (cbp+1);
	tr_lli_input(s0);

lliret_1:
	m_freem(m0);
	splx(s);
	splx(s1);
}

/*
 * read frame off the board.
 */
#define DRAINFRM	0
#define IPFRM		1
#define LLCFRM		2
static int
fv_recv(struct fv_info *fv, volatile struct tr_rcv_list *rcvlist)
{
	register char *cp, *dp;
	LLC1 *llcp;
	FVIHDR ihdr;
	u_short *sri = 0;
	register struct mbuf *m1;
	register struct tr_data_buf *dbuf;
	register int hlen, frm;
	register int l, tlen, off, mlen;
	register int index = 0;
	u_short	port = 0;
	int snoopflag = 0;
	struct mbuf *m0 = 0;
	TR_MAC_HDR *mh = &ihdr.machdr;
	struct ifqueue *ifq = 0;
	FVMEM *mem = fv->fv_mem;
	int length = rcvlist->rcv_frame_size;
	int rpadlen = sizeof(TR_RII), rilen = 0;

	tlen = length;
	dbuf = IOBP(rcvlist->rcv_iobh[0], struct tr_data_buf*); CHKDB(dbuf);

	/* 1: copyin just headers */
	VMEIN((char*)dbuf,(char*)&ihdr, sizeof(ihdr));

	/* 2: Count packet/bytes regardless of error */
	fv->fv_if.if_ipackets++;
	fv->fv_if.if_ibytes += length;

	/* 3: Check small packet size */
	if (length < sizeof(*mh)) {
		printf("fv%d: packet too small(%d)\n", fv->fv_unit, length);
		snoopflag |= SNERR_TOOSMALL|SN_ERROR;
		goto read_ret;
	}

	/* 4: get hdr ptrs. SRI PAD must be applied uncoditionally */
	ASSERT((fv->fv_openop&TR_PAD_ROUTE_FIELD) != 0);
	if (mh->t_mac_sa[0]&TR_MACADR_RII) {
		sri = (u_short*)&mh->t_mac_rii;
		rilen = (mh->t_mac_rii & TR_RIF_LENGTH) >> 8;
		if (rilen <= 2) {
			sri = 0;
			rilen = 0;
		}
	} else {
		sri = 0;
		rilen = 0;
	}
	llcp = (LLC1 *)&ihdr.llc2;

	if (rilen > sizeof(TR_RII) || rilen < 0) {
		XDP(("WARNING: invalid SRI len=%d\n",rilen));
#if DBG_LVL >= DBG_LVL_DRV
		fv_hexdump((char*)mh, 40);
#endif
		goto read_ret;
	}

	/* 5: Quick parse for frame type */
	if ((mh->t_mac_fc & TR_FC_TYPE) == TR_FC_TYPE_LLC) {
		if (llcp->llc1_dsap == TR_IP_SAP) {
			hlen = sizeof(*mh)+sizeof(LLC1)+sizeof(SNAP);
			frm = IPFRM;
		} else {
			hlen = sizeof(*mh);
			frm = LLCFRM;
		}
	} else {
		/* XXX: currently applied 32 and pointing MV */
		hlen = sizeof(*mh);
		frm = DRAINFRM;
	}

	/* 6: purge my own frame */
	if ((mh->t_mac_sa[5] != fv->fv_enaddr[5]) ||
	    (mh->t_mac_sa[4] != fv->fv_enaddr[4]) ||
	    (mh->t_mac_sa[3] != fv->fv_enaddr[3]) ||
	    (mh->t_mac_sa[2] != fv->fv_enaddr[2]) ||
	    (mh->t_mac_sa[1] != fv->fv_enaddr[1]) ||
	    ((mh->t_mac_sa[0]&~TR_MACADR_RII) != fv->fv_enaddr[0]))
		goto chksnoop;
	goto read_ret;
	/* NOT REACHED... */

chksnoop:
	if (snoopflag && !RAWIF_SNOOPING(&fv->fv_rawif)) {
		DP(("fv%d: DROP ftype=%d, err=%x\n",fv->fv_unit,frm,snoopflag));
		goto read_ret;
	}

	/* 7: Move in a frame */
#define TRPAD (sizeof(TOKENBUFHEAD))
	mlen = min(VCL_MAX, tlen+TRPAD);
	if ((m0 = m_vget(M_DONTWAIT, mlen, MT_DATA)) == 0) {
		DP(("fv%d: no mbuf for READ\n",fv->fv_unit));
		snoopflag |= SN_ERROR|SNERR_NOBUFS;
		goto drop;
	}

	mlen -= TRPAD;
	cp = mtod(m0, char *)+TRPAD;
	mh = (TR_MAC_HDR*)cp;
	dp = (char*)dbuf;
	for (m1 = m0, off = 0, index = 0; tlen > 0; ) {
		tlen -= mlen;
		while (mlen > 0) {
			l = min(mlen, TR_DATA_BUFFER_SIZE-off);
			if (l&1)
				VMEIN(dp, cp, l+1);
			else
				VMEIN(dp, cp, l);
			mlen -= l; cp += l;
			if (mlen <= 0 && tlen <= 0)
				goto cpdone;
			if (l >= TR_DATA_BUFFER_SIZE || off != 0) {
				if (++index == TR_IOB_HEADERS) {
					rcvlist = (volatile struct tr_rcv_list*)
						TR_NEXT_RCVLIST(fv,rcvlist,mem);
					index = 0;
				}
				dbuf = IOBP(rcvlist->rcv_iobh[index],
					struct tr_data_buf*); CHKDB(dbuf);
				dp = (char*)dbuf;
				off = 0;
			} else {
				off = l;
				dp += l;
			}
		}

		if (tlen <= 0)
			break;
		mlen = min(VCL_MAX, tlen);
		if ((m1->m_next = m_vget(M_DONTWAIT, mlen, MT_DATA)) == 0) {
			DP(("fv%d: no mbuf for READ 2\n",fv->fv_unit));
			snoopflag |= SN_ERROR;
			goto drop;
		}
		m1 = m1->m_next;
		cp = mtod(m1, char*);
	}
cpdone:
	IF_INITHEADER(mtod(m0, char*), &fv->fv_if, TRPAD+hlen);

	/* 8: Do snoop iff applicable */
	if (RAWIF_SNOOPING(&fv->fv_rawif)) {
		snoop_input(&fv->fv_rawif,snoopflag,(char*)mh,m0,length-hlen);
		if (snoopflag&~SN_PROMISC)
			goto read_ret;
	}

	/* 9: Final frame type adjustment */
	if (frm == IPFRM) {
                int roff = rpadlen-rilen;
		SNAP *snap=(SNAP*)(((char*)mh)+hlen-sizeof(SNAP));
		port = (snap->snap_etype[0]<<8)+(snap->snap_etype[1]);
#ifdef HOSTLLC
        {
                dlsap_family_t *dlp = dlsap_find(llcp->llc1_dsap,DL_LLC_ENCAP);
                if (dlp) {
                        IF_INITHEADER(mtod(m0, char*), &fv->fv_if, TRPAD+roff);
                        if ((*dlp->dl_infunc)(dlp, &fv->fv_if, m0, mh)) {
                                DP(("dl_infunc accepted\n"));
                                goto read_ret;
                        }
                        DP(("dl_infunc rejected\n"));
                } else {
                        DP(("dlsap_find failed for %x\n",(int)llcp->llc1_dsap));
                }

        }
#endif

#ifdef IFRMTRC
#ifdef IFRMRCV
		{
		struct ip *ip;
		char *chptr;
		chptr = (char*)mh+hlen;
		ip = (struct ip *)((char*)mh+hlen);
		if (ip->ip_p == 0x06) {		/* TCP */
		    struct tcphdr *tcp = (struct tcphdr*)(chptr+20);

		    if (tcp->th_dport == 514)
		    	IFRM_TRC(chptr+20+20);	/* skip IP + TCP headers */
		}
		}
#endif
#endif
	} else if (frm == LLCFRM) {
		int roff = rpadlen-rilen;
		if (roff > 0) {
			char *tbp = mtod(m0, char*)+TRPAD+roff;
			bcopy((char*)&ihdr, tbp, (sizeof(TR_MAC)+rilen));
			/* mh has been clobbered, so reset it */
			mh = (TR_MAC_HDR*)tbp;
		}
		IF_INITHEADER(mtod(m0, char*), &fv->fv_if, TRPAD+roff);
#ifdef HOSTLLC
	{
		dlsap_family_t *dlp = dlsap_find(llcp->llc1_dsap,DL_LLC_ENCAP);
		if (dlp) {
			if ((*dlp->dl_infunc)(dlp, &fv->fv_if, m0, mh)) {
				DP(("dl_infunc accepted\n"));
				goto read_ret;
			}
			DP(("dl_infunc rejected\n"));
		} else {
			DP(("dlsap_find failed for %x\n",(int)llcp->llc1_dsap));
		}
		port = TR_PORT_LLC;
	}
#else
		fv_read_llc2(m0);
		goto read_ret;
#endif
	} else {
		port = TR_PORT_MAC;
	}

	/* 10: check mcast/bcast */
	if (TOKEN_ISGROUP(mh->t_mac_da)) {
		fv->fv_if.if_imcasts++;
		if (TOKEN_ISBROAD(mh->t_mac_da))
			m0->m_flags |= M_BCAST;
		else
			m0->m_flags |= M_MCAST;
	}

	switch (port) {
	case ETHERTYPE_IP:
		ifq = &ipintrq;
		IFQ_LOCK(ifq);
       		if (IF_QFULL(ifq)) {
			IF_DROP(ifq);
			fv->fv_if.if_iqdrops++;
			IFQ_UNLOCK(ifq);
			goto drop;
		}
		IF_ENQUEUE_NOLOCK(ifq, m0);
		IFQ_UNLOCK(ifq);
		schednetisr(NETISR_IP);
		goto read_ret;
	case ETHERTYPE_ARP:
		if (sri) {
			*sri &= ~TR_RIF_SRB_NBR;
			*sri ^= TR_RIF_DIRECTION;
		}
		srarpinput(&fv->fv_ac, m0, sri);
		goto read_ret;
	default:
#ifdef _IRIX4
		if (snif_input(m0, mh))
			goto read_ret;
#endif
		if (RAWIF_DRAINING(&fv->fv_rawif)) {
	        	drain_input(&fv->fv_rawif, port, (caddr_t)mh, m0);
			goto read_ret;
		}
 		fv->fv_if.if_noproto++;
		goto drop;
        }
drop:
	if (RAWIF_SNOOPING(&fv->fv_rawif))
		snoop_drop(&fv->fv_rawif,snoopflag,(caddr_t)mh,length);
	if (RAWIF_DRAINING(&fv->fv_rawif))
		drain_drop(&fv->fv_rawif, port);
	if (m0)
	        m_freem(m0);
read_ret:
	if ((snoopflag&~SN_PROMISC) != 0)
		fv->fv_if.if_ierrors++;
	return(length);
}

/*
 * Process a transmit status interrupt from the fv1600 board
 */
static int
tr_process_xmit_status(struct fv_info *fv, SSB *ssb)
{
	volatile struct tr_xmit_list *last;
	volatile struct tr_xmit_list *xmitlist;
	u_short	error = 0;
	FVMEM *mem = fv->fv_mem;

	if (ssb->ssb_stat & (TR_XMIT_I_FRAME_ACK|TR_XMIT_I_READY)) {
		__psunsigned_t *bp;
		struct mbuf *m0 =
			m_vget(M_DONTWAIT,(sizeof(int)+sizeof(*ssb)),MT_DATA);
		if (!m0) {
			printf("fv%d: no mbuf for process xmit stat\n",
					fv->fv_unit);
			return(-1);
		}
		bp = mtod(m0, __psunsigned_t*);
		bp[0] = (__psunsigned_t)fv;
		bcopy((char*)ssb, (char*)(&bp[1]), sizeof(*ssb));
		m0->m_len = sizeof(__psunsigned_t) + sizeof(*ssb);
#ifdef IWAITDBG
		if (babble) {
			printf("got ifr stat(%x)\n",(u_int)ssb->ssb_stat);
			babble--;
		}
#endif
		fv_ifr_stat(m0);
		goto xmit_status_done;
	}
	last = LISTP(ssb, volatile struct tr_xmit_list *);
	CHKXL(last);
	if (((ssb->ssb_stat & TR_XMIT_CMD_COMPLETE) || 
	    (ssb->ssb_stat & TR_XMIT_LIST_ERR)) && 
	    (fv->fv_state != FV_STATE_OK)) {
		DP(("fv%d: xmit: board not operational\n", fv->fv_unit));
		return(0);
	}
	if (ssb->ssb_stat & TR_XMIT_LIST_ERR) {		/* list error */
		XDP(("fv%d: list error, addr = %x, ssb_stat = %x\n", fv->fv_unit, last, ssb->ssb_stat));
		fv->fv_if.if_oerrors++;
		goto xrearm;
	}

	xmitlist = fv->xmitlist_first;
	CHKXL(xmitlist);
	while ((__psunsigned_t)TR_PREV_XMITLIST(mem, xmitlist) != (__psunsigned_t)last) {
		/* See if there was a xmit list error that the board caught */
		if (xmitlist->xmit_cstat & TR_XMITL_ERR) {
			fv->fv_statlog.xmit_list++;
			fv->fv_if.if_oerrors++;
			XDP(("XL error(%x)!!\n", xmitlist->xmit_cstat));
			goto xrearm;
		}
		/* free next list chain and its data buffers */
		xmitlist = (volatile struct tr_xmit_list*)fv_free_xmitlist(fv,xmitlist);
		CHKXL(xmitlist);
	}

	if ((__psunsigned_t)xmitlist == (__psunsigned_t)fv->xmitlist_free) {
		/* no active frames left */
		fv->xmitlist_first = 0;
		fv->xmitlist_last = 0;
	} else { 			/* first transmit list beyond last */
		fv->xmitlist_first = xmitlist;
	}
xmit_status_done:
	/* initiate a new transmit command if it's needed */
	if (ssb->ssb_stat & TR_XMIT_CMD_COMPLETE) {
#ifdef IWAITDBG
		if (babble)
			printf("TRANSMIT RESTARTED!!!!\n");
#endif
		XDP(("XMIT COMPLETE!!\n"));
		goto xrearm;
	}
	return(error);

xrearm:
	fv_setxbuf(fv);
	return(fv_transmit(fv));
}

/*
 * Process the receive pending interrupt
 */
static int
fv_process_rcv_pending(struct fv_info *fv)
{
	FVIO *io = fv->FVIO;

	/* make sure the board is operational */
	if (fv->fv_state != FV_STATE_OK) {
		DP(("fv%d: stray rcv_pending\n",fv->fv_unit));
		io->sifcmd_stat=TR_CMD_INT_ADAPT|TR_CMD_RCV_CANCEL|TR_STAT_INTR;
		return(0);
	}
	io->sifcmd_stat=TR_CMD_INT_ADAPT|TR_CMD_RCV_VALID|TR_STAT_INTR;
	return(0);
}

/*
 * Process the LLC Status interrupt.
 */
static void
fv_process_llc_status(struct fv_info *fv, TR_ICB *icb)
{
	LLI_CB *cbp;
	struct mbuf *m0;

	LP(("fv%d: LLC_STATUS: sid=%x code=%x\n",
			fv->fv_unit, icb->station_id_s, icb->llc_stat_code));

	if ((m0=m_vget(M_DONTWAIT,(sizeof(*cbp)+sizeof(*icb)),MT_DATA))==0) {
		DP(("no buf for llc status\n"));
		return;
	}

#ifdef DEBUG
        if (icb->llc_stat_code==TR_FRMR_RCVD ||
            icb->llc_stat_code==TR_FRMR_SENT) {
            printf("fv%d: Frame Reject Data %x %x %x\n", fv->fv_unit,
                icb->frmr_data_hi,icb->frmr_data_mid, icb->frmr_data_lo);
        }
#endif
	cbp = mtod(m0, LLI_CB*);
	cbp->port = fv->fv_unit;
	cbp->command = LLI_LLC_STATUS;
	cbp->param_blk = (cbp+1);
	bcopy((char*)icb, (char*)cbp->param_blk, sizeof(*icb));
	m0->m_len = (sizeof(*cbp)+sizeof(*icb));
	fv_lli(m0);
}

/*
 * Free the transmit list:
 */
static volatile struct tr_xmit_list *
fv_free_xmitlist(struct fv_info *fv, volatile struct tr_xmit_list *xmitlist)
{
	register int len;
	register int i = 0;
	register FVMEM *mem = fv->fv_mem;

	CHKXL(xmitlist);
	len = xmitlist->xmit_frame_size;
	xmitlist->xmit_cstat = 0;		/* zero out status */
	fv->n_free_xmitlist++;			/* bump count of free bufs */
	for (;;) {
		len -= (xmitlist->xmit_iobh[i].data_count & 0x7fff);
		if (len <= 0)
			break;
		if (++i == TR_IOB_HEADERS) {
			i = 0;
			xmitlist = TR_NEXT_XMITLIST(fv, xmitlist, mem);
			CHKXL(xmitlist);
			xmitlist->xmit_cstat = 0;
			fv->n_free_xmitlist++;
	    	}
	}
	return(TR_NEXT_XMITLIST(fv, xmitlist, mem));
}

/*
 * Token-Ring output.
 */
static int
if_fvoutput(struct ifnet *ifp, struct mbuf *m0, struct sockaddr *dst)
{
	char *map;
	TR_MAC *mh;
	LLC1 *llcp;
	SNAP *snap;
	int s, etyp;
	struct mbuf *m1;
	struct fv_info *fv;
	u_char maddr[TR_MAC_ADDR_SIZE];
	extern int looutput(struct ifnet *, struct mbuf *, struct sockaddr *);

	int error = 0;
	int sri_len = 0;
	u_short *sri = 0;
	struct mbuf *mloop = 0;
	u_short	ftyp = TR_FTYPE_DIRECT;

	/* 1: check and get info struct */
	ASSERT((ifp->if_unit >= 0) && (ifp->if_unit < FV_MAXBD));
	fv = &fv_info[ifp->if_unit];
	ASSERT(0 != fv->FVIO && ifp == &fv->fv_if);
	ASSERT(IFNET_ISLOCKED(ifp));

	/* 2: make sure board has been initialized properly */
	if (fv->fv_state != FV_STATE_OK || iff_dead(ifp->if_flags)) {
		DP(("fv%d: xmit: board not operational\n", fv->fv_unit));
		error = ENETDOWN; goto output_ret;
	}

	switch (dst->sa_family) {
	case AF_INET: {
		/* int trail;	** use trailer = always false in TR */
		struct in_addr *idst = &((struct sockaddr_in *)dst)->sin_addr;
		if (!arpresolve(&fv->fv_ac,m0,idst,maddr,&trail))
			return(0);      /* arp will hang onto m0 */

		/* At this point, ARP resolved,
		 * which means, SRI is also learned
		 * whether it is over bridge or not.
		 */
		if (TOKEN_ISBROAD(maddr)) {
			if ((mloop = m_copy(m0, 0, M_COPYALL)) == 0) {
				error = ENOBUFS; goto output_ret;
			}
			map = (fv_batype == 1) ? fv_baddr_c : fv_baddr_f;
		} else {
			map = (char*)&maddr[0];
		}
		etyp = ETHERTYPE_IP;

		/* prepare SRCROUTE for resolved IP packets */
		if ((fv->fv_if.if_flags & IFF_ALLCAST) == 0) {
			sri_len = 0;
			break;
		}
		if (TOKEN_ISGROUP(map)) {
			/* This is IP broadcat */
			sri = &(fv->nullsri);
			sri_len = 2;
		} else if ((sri = srilook(map, 1)) != 0) {
			/* This IP unicast for remote ring */
			sri_len = ((*sri)&TR_RIF_LENGTH)>>8;
		} else {
			/* This is IP unicast for local ring */
			sri_len = 0;
		}
	} break;

#ifdef HOSTLLC /* { */
	case AF_SDL: {
		struct sockaddr_sdl *sdl;
	
		sdl = (struct sockaddr_sdl *)dst;
		map = (char *)sdl->ssdl_addr;
		sri = (u_short *)&map[TR_MAC_ADDR_SIZE];
		etyp = (int)sdl->ssdl_ethersap;
		sri_len = sdl->ssdl_addr_len - TR_MAC_ADDR_SIZE;

		if (sdl->ssdl_addr_len < TR_MAC_ADDR_SIZE) {
			error = EAFNOSUPPORT;
			goto output_ret;
		}

		if (sri_len > 0) {
			/* If SRI is provided,
			 * then just honor it with sanity check.
			 */
			if ((fv->fv_if.if_flags & IFF_ALLCAST) == 0) {
				error = EAFNOSUPPORT;
				goto output_ret;
			}
			if ((sri_len > TR_MAC_RIF_SIZE) ||
			    (sri_len != (((*sri)&TR_RIF_LENGTH)>>8))) {
				DP(("INVALID SRI: sri_len = %d, given=%d\n",
					(u_int)sri_len,
					(u_int)(((*sri)&TR_RIF_LENGTH)>>8)));
				error = EINVAL;
				goto output_ret;
			}
		} else if (TOKEN_ISBROAD(map)) {
			/* If not, just provide null-sri for broadcast only.
			 */
			map = (fv_batype == 1) ? fv_baddr_c : fv_baddr_f;
			sri = &(fv->nullsri);
			sri_len = 2;
		}

		/* 4: Allocate MAC/SRI/LLC/SNAP header space */
		if ((m1 = m_get(M_DONTWAIT, MT_DATA)) == 0) {
			error = ENOBUFS; goto output_ret;
		}
		m1->m_next = m0;
		m0 = m1;
		m0->m_len = sizeof(*mh)+sri_len;

		/* 5: setup MAC header */
		mh = mtod(m0, TR_MAC*);
		mh->mac_ac = TR_AC_FRAME;
		mh->mac_fc = TR_FC_TYPE_LLC;
		bcopy(fv->fv_enaddr, mh->mac_sa, TR_MAC_ADDR_SIZE);
		bcopy(map, mh->mac_da, TR_MAC_ADDR_SIZE);

		/* 6: insert SRCROUTE info into xmit header */
		if (sri_len > 0) {
			char *tsri = ((char*)mh)+sizeof(*mh);
			bcopy((char*)sri,tsri,sri_len);
			mh->mac_sa[0] |= TR_MACADR_RII;
		}

		s = splimp();
		error = fvsend((caddr_t)m0, fv, ftyp, fv->ip_sid,
				TR_IP_SAP, TR_IP_PACKET, 0, 0, 0);
		splx(s);
		goto output_ret;
	}
#endif /* HOSTLLC } */

	case AF_UNSPEC:

# define EP ((struct ether_header *)&dst->sa_data[0])
		etyp = EP->ether_type; map = (char*)&EP->ether_dhost[0];
		if (TOKEN_ISBROAD(map)) {
			map = (fv_batype == 1) ? fv_baddr_c : fv_baddr_f;
		}
# undef EP
		/* prepare SRCROUTE for ARP packets */
		if ((fv->fv_if.if_flags & IFF_ALLCAST) == 0) {
			sri_len = 0;
			break;
		}
		if (TOKEN_ISGROUP(map)) {
			/* This is ARP request */
			sri = &(fv->nullsri);
			sri_len = 2;
		} else if ((sri = srilook(map, 1)) != 0) {
			/* This ARP response to remote ring */
			sri_len = ((*sri)&TR_RIF_LENGTH)>>8;
		} else {
			/* This is ARP response to local ring */
			sri_len = 0;
		}
		break;

	case AF_RAW:
		s = splimp();

		/* NO NEED to prepare SRCROUTE, it is RAW packet */
		error = fvsend((caddr_t)m0, fv, ftyp, fv->ip_sid,
				TR_IP_SAP, TR_IP_PACKET, 0, 0, 0);
		splx(s);
		goto output_ret;

	default:
		DP(("fv%d: can not handle address family 0x%x",
				fv->fv_unit, dst->sa_family));
		error = EAFNOSUPPORT; goto output_ret;
	}

	/* 3: prepare for SRCROUTE is done already */

	/* 4: Allocate MAC/SRI/LLC/SNAP header space */
	if ((m1 = m_get(M_DONTWAIT, MT_DATA)) == 0) {
		error = ENOBUFS; goto output_ret;
	}
	m1->m_next = m0;
	m0 = m1;

	/* 5: setup MAC header */
	mh = mtod(m0, TR_MAC*);
	mh->mac_ac = TR_AC_FRAME;
	mh->mac_fc = TR_FC_TYPE_LLC;
	bcopy(fv->fv_enaddr, mh->mac_sa, TR_MAC_ADDR_SIZE);
	bcopy(map, mh->mac_da, TR_MAC_ADDR_SIZE);

	/* 6: insert SRCROUTE info into xmit header */
	if (sri_len > 0) {
		char *tsri = ((char*)mh)+sizeof(*mh);
		bcopy((char*)sri,tsri,sri_len);
		mh->mac_sa[0] |= TR_MACADR_RII;
	}

	/* 7: setup LLC header */
	if (fv->flags & TR_ONCHIPLLC) {
		snap = (SNAP*)(((char*)mh)+sizeof(*mh)+sri_len);
		m0->m_len = sizeof(*mh)+sri_len+sizeof(*snap);
		ftyp = TR_FTYPE_UI;
	} else {
		llcp = (LLC1*)(((char*)mh)+sizeof(*mh)+sri_len);
		llcp->llc1_dsap = TR_IP_SAP;
		llcp->llc1_ssap = TR_IP_SAP;
		llcp->llc1_cont = RFC1042_CONT;

		snap = (SNAP*)(((char*)llcp)+sizeof(*llcp));
		m0->m_len = sizeof(*mh)+sri_len+ sizeof(*llcp)+sizeof(*snap);
	}

	/* 8: setup SNAP */
	snap->snap_org[0] = RFC1042_K2;
	snap->snap_org[1] = RFC1042_K2;
	snap->snap_org[2] = RFC1042_K2;
	snap->snap_etype[0] = etyp>>8;
	snap->snap_etype[1] = etyp&0xff;

	/* 9: send out packet */
	if (mloop) {
		looutput(&loif, mloop, dst);
		mloop = 0;
	}
	s = splimp();
	error = fvsend((caddr_t)m0, fv, ftyp, fv->ip_sid,
			TR_IP_SAP,TR_IP_PACKET,0,0,sri_len);
	splx(s);
output_ret:
	if (error)
	{
		ifp->if_oerrors++;
 		if (ifp->if_flags & IFF_DEBUG)
 		    printf ("if_fvoutput(): error = %d.\n", error);
	}

	if (mloop)
		m_freem(mloop);
	m_freem(m0);
	return(error);
}

/*
 * fvstart5:
 */
static void
fvstart5(struct fv_info *fv)
{
	u_short newopt;
	FVIO *io = fv->FVIO;
	FVMEM *mem = fv->fv_mem;

	if (fv->reset_tid) {
		untimeout(fv->reset_tid);
		fv->reset_tid = 0;
	}

	if (fv_getscb(fv)) {
		DP(("fv%d: start5: scb=%x\n",fv->fv_unit,mem->tr_scb.scb_cmd));
		fv->reset_tid = cputimeout((void (*)())fvstart5,
					   (caddr_t)fv, TR_INCR_TIMEOUT);
		return;
	}

	newopt = fv->fv_openop;
	newopt |= TR_PASS_MAC_FRAME|TR_PASS_ATTN_FRAME|TR_PASS_BEACON;
	if (!(fv->flags&TR_ONCHIPLLC))
		newopt |= TR_COPY_ALL_MAC_FRAMES;
	if (fv->flags&TR_PROMISC)
		newopt |= TR_COPY_ALL_NON_MAC;
	DP(("fv%d: start5: MOD open opt = %x\n", fv->fv_unit,(u_int)newopt));
	mem->tr_scb.scb_parm1 = newopt;
	mem->tr_scb.scb_cmd = TR_CMD_MOD_OPEN_PARMS;
	io->sifcmd_stat = TR_CMD_INT_ADAPT | TR_CMD_EXECUTE | 
	        	TR_CMD_SCB_REQUEST | TR_STAT_INTR;
	fv->fv_state = FV_STATE_OK;
	wakeup((caddr_t)&fv->fv_state);
	return;
}

/*
 * fvstart4:
 *	1. verify open IP sap.
 *	2. hang xmit.
 */
static void
fvstart4(struct fv_info *fv)
{
	int error;

	if (fv->reset_tid) {
		untimeout(fv->reset_tid);
		fv->reset_tid = 0;
	}

	if (fv->flags&TR_ONCHIPLLC) {
		if (fv->cmd_Flags[TR_CMD_OPEN_SAP]&CMD_BUSY) {
			DP(("fv%d: fvstart4: OPEN_SAP not complete.\n", 
			    fv->fv_unit));
			fv->reset_tid = cputimeout((void (*)())fvstart4,
					   (caddr_t)fv, TR_INCR_TIMEOUT);
			return;
		}

		/* check open IP sap command status */
		if ((error = fv->cmd_Status[TR_CMD_OPEN_SAP]) != TR_OPEN_SAP_OK) {
			printf("fv%d: IP open: ", fv->fv_unit);
			if (error == TR_OPEN_SAP_INV_OPTS)
				printf("invalid options\n");
			else if (error == TR_OPEN_SAP_UNAUTH)
				printf("unauthorized access priority\n");
			else if (error == TR_OPEN_SAP_TOOBIG)
				printf("a parameter has exceeded max limit\n");
			else if (error == TR_OPEN_SAP_INV_SAP)
				printf("invalid SAP value\n");
			else if (error == TR_OPEN_SAP_BAD_GRP)
				printf("nonexistent group\n");
			else if (error == TR_OPEN_SAP_RES_NA)
				printf("resources not available\n");
			else if (error == TR_OPEN_SAP_MAX_MEM)
				printf("group has too many members\n");
			goto bad4;
		}
	}
	else {
		if (fv_getscb(fv)) {
			DP(("fv%d: fvstart4: failed to get scb\n",fv->fv_unit));
			fv->reset_tid = cputimeout((void (*)())fvstart4,
					   (caddr_t)fv, TR_INCR_TIMEOUT);
			return;
		}
	}

	DP(("fv%d: start4: IP SID = %x\n", fv->fv_unit, (int)fv->ip_sid));

	/* Hang xmit cmd to the board */
	if (error = fv_transmit(fv))
		goto bad4;
	DP(("fv%d: transmit set\n", fv->fv_unit));

	fv->reset_tid = cputimeout((void (*)())fvstart5,
				   (caddr_t)fv, TR_INCR_TIMEOUT);
	return;
bad4:
	fv->fv_state = FV_STATE_SICK;
	wakeup((caddr_t)&fv->fv_state);
}

/*
 * fvstart3:
 *	1. verify open.
 *	2. hang recv.
 *	3. open IP sap.
 */
static void
morest3(struct fv_info *fv)
{
	int error;

	if (fv->reset_tid) {
		untimeout(fv->reset_tid);
		fv->reset_tid = 0;
	}

	if (fv_getscb(fv)) {
		DP(("fv%d: morest3: failed to get scb\n",fv->fv_unit));
		fv->reset_tid = cputimeout((void (*)())morest3,
					   (caddr_t)fv, TR_INCR_TIMEOUT);
		return;
	}

	/* open IP sap */
	error = fv_open_ip_sap(fv);
	if (error) {
		DP(("fv%d: open (ip) sap err = %x\n", fv->fv_unit, error));
		goto badm3;
	}
	fv->cmd_Flags[TR_CMD_OPEN_SAP] |= CMD_BUSY;
	fv->fv_state = FV_STATE_OPENSAP;
	return;
badm3:
	fv->fv_state = FV_STATE_SICK;
	wakeup((caddr_t)&fv->fv_state);
}

static void
fvstart3(struct fv_info *fv)
{
	int error;

	if (fv->reset_tid) {
		untimeout(fv->reset_tid);
		fv->reset_tid = 0;
	}
	if (fv->cmd_Flags[TR_CMD_OPEN]&CMD_BUSY) {
		fv->reset_tid = cputimeout((void (*)())fvstart3,
					   (caddr_t)fv,TR_INCR_TIMEOUT);
		return;
	}

	/* check open command status */
	error = fv->cmd_Status[TR_CMD_OPEN];
	if ((error&TR_OPEN_CMD_COMPLETE) == 0) {
		if (error & TR_OPEN_NODE_ADDR_ERR)
			printf("fv%d: invalid node address\n",fv->fv_unit);
		if (error & TR_OPEN_LIST_SIZE_ERR)
			printf("fv%d: invalid list size\n",fv->fv_unit);
		if (error & TR_OPEN_BUF_SIZE_ERR)
			printf("fv%d: invalid buffer size\n",fv->fv_unit);
		if (error & TR_OPEN_XMIT_BUFCNT_ERR)
			printf("fv%d: too few recv buffers\n", fv->fv_unit);
		if (error & TR_LLC_ERR)
			printf("fv%d: invalid LLC options\n",fv->fv_unit);
		if (error & TR_OPEN_ERR) {
			u_int phase = ((error & TR_OPEN_PHASE) >> 4);
			u_int err = (error & TR_OPEN_ERR_CODE);
			printf("fv%d: %s phase: %s\n",
			    fv->fv_unit,OpenPhases[phase], OpenErrs[err]);
		}
		goto bad3;
	}

	/* RECEIVE cmd MUST be the first cmd after OPEN. */
	if (error = fv_receive(fv)) {
		goto bad3;
	}
	DP(("fv%d: start3: sts = %x\n", fv->fv_unit, error));

	if (!(fv->flags&TR_ONCHIPLLC)) {
		fvstart4(fv); return;
	}

	morest3(fv);
	return;
bad3:
	fv->fv_state = FV_STATE_SICK;
	wakeup((caddr_t)&fv->fv_state);
}

#if (DBG_LVL >= DBG_LVL_DRV)
static char *init_rc[] = {
	"",
	"invalid initialization block",
	"invalid options",
	"invalid receive burst size",
	"invalid transmit burst count",
	"invalid DMA abort threshold",
	"invalid SCB",
	"invalid SSB",
	"DIO parity error",
	"DMA timeout",
	"DMA parity error",
	"DMA bus error",
	"DMA data error",
	" adapter check"
};
#endif

/*
 * fvstart2:
 *
 *	1. verify initialization.
 *	2. open the board.
 */
static void
fvstart2(struct fv_info *fv)
{
	FVIO *io;
	int error;
	u_short sts, speed;
	FVMEM *mem = fv->fv_mem;
	
	if (fv->reset_tid) {
		untimeout(fv->reset_tid);
		fv->reset_tid = 0;
	}
	io = fv->FVIO;
	sts = io->sifcmd_stat;
	fv->inittimo++;
	DP(("fv%d: start2: sts = 0x%x, mem=%x, io=%x\n", fv->fv_unit, 
		 (int)sts, mem, io));
	if (sts & TR_STAT_ERROR) {
		DP(("fv%d: INIT FAILED: %s\n", fv->fv_unit,init_rc[sts&0xf]));
		goto start2_fail;
	}
	
	if ((sts & (TR_STAT_INIT|TR_STAT_TEST)) != 0) {
		if (fv->inittimo <= 11) {
			fv->reset_tid = cputimeout((void (*)())fvstart2,
						   (caddr_t)fv, HZ);
			return;
		}
		goto start2_fail;
	}
	fv->inittimo = 0;

	fv->rtry = 0;
	if (((fv->flags&TR_EDTINIT) == 0) || (fv->flags & TR_HARDRESET)) {
		if ((fv->flags & TR_HARDRESET) &&
		   (fv->fv_state != FV_STATE_CLOSE) &&
		   ((bcmp((caddr_t)&(mem->tr_scb),tr_piscb,sizeof(tr_piscb)) ||
    	    	    bcmp((caddr_t)&(mem->tr_ssb),tr_pissb,sizeof(tr_pissb))))) {
			DP(("fv%d: invalid ssb/scb\n",fv->fv_unit));
			goto start2_fail;
		}

		fv_fetbdm(io, TR_INIT_ADDR, (u_short*)&fv->ia, sizeof(fv->ia));
		fv_fetbdm(io, fv->ia.speedp, (u_short*)&speed, sizeof(speed));
		if (speed == 0) {
			/* 4 Mbit */
			inventory_t *inv = find_inventory(0, INV_NETWORK,
				INV_NET_TOKEN, INV_TOKEN_FV, fv->fv_unit, 1);
#ifdef _IRIX4
			if (inv) inv->state = 0;
#else
			if (inv) inv->inv_state = 0;
#endif /* _IRIX4 */
			else add_to_inventory(INV_NETWORK, INV_NET_TOKEN,
						INV_TOKEN_FV, fv->fv_unit, 0);
			fv->flags &= ~TR_16_MBIT;
			fv->fv_if.if_mtu = min(fv_mtu, TRMTU_4M);
		}
		fv->fv_if.if_mtu = max(15, fv->fv_if.if_mtu);
		fv_setnullsri(fv);

		/* Read burnin mac address iff not set by APPS */
		if (fv->ia.biap == 0xffff) {
			printf("fv%d:bad burnin address\n",fv->fv_unit);
			goto start2_fail;
		}
		if (!fv->addrset) {
			fv_fetbdm(io, fv->ia.biap,
				(u_short*)fv->fv_bia,sizeof(fv->fv_bia));
			bcopy(fv->fv_bia, fv->fv_enaddr, sizeof(fv->fv_enaddr));
		}
		fv_fetbdm(io, fv->ia.swlp, (u_short*)fv->mcl,sizeof(fv->mcl));
		if (showconfig) {
			printf("fv%d: tokenring address %s\n",
				fv->fv_unit, ether_sprintf(fv->fv_enaddr));
		}
		fv->flags |= TR_EDTINIT;
	}

	/* set up MAC/SNAP header:
	 * the LLC header is created by the LLC running on the
	 * token-ring board, for now.
	 */
	fv->tr_hdr.t_mac_ac = 0x10;
	fv->tr_hdr.t_mac_fc = 0x40;
	fv->tr_hdr.t_snap_org[0] = RFC1042_K2;
	fv->tr_hdr.t_snap_org[1] = RFC1042_K2;
	fv->tr_hdr.t_snap_org[2] = RFC1042_K2;
	fv->tr_hdr.t_snap_etype[0] = (ETHERTYPE_IP >> 8);
	fv->tr_hdr.t_snap_etype[1] = (ETHERTYPE_IP & 0xff);
	bcopy(fv->fv_enaddr,(char*)fv->tr_hdr.t_mac_sa,sizeof(fv->fv_enaddr));

	fv_setrbuf(fv);
	fv_setxbuf(fv);
	tr_format_open_block(fv);
	error = fvIssueCmd(fv, TR_CMD_OPEN, BDMEM(open_block, u_int)); 
	if (error)
		goto start2_fail;

	fv->cmd_Flags[TR_CMD_OPEN] |= CMD_BUSY;
	fv->fv_state = FV_STATE_OPEN;
	fv->reset_tid = cputimeout((void (*)())fvstart3,
				   (caddr_t)fv, TR_OPEN_TIMEOUT*HZ);

	return;

start2_fail:
	fv->inittimo = 0;
	if (fv->rtry <= 3) {	/* retry 3 times */
		fvreset(fv, 1);
	} else {
		fv->fv_state = FV_STATE_SICK;
		wakeup((caddr_t)&fv->fv_state);
		printf("fv%d: firmware failed to start\n", fv->fv_unit);
	}
}
/*
 * fvstart1:
 *
 *	1. verify reset completion.
 *	2. initialize the board.
 */
static void
fvstart1(struct fv_info *fv)
{
	FVIO *io = fv->FVIO;
	u_char sts = io->vme_status;

	if (fv->reset_tid) {
		untimeout(fv->reset_tid);
		fv->reset_tid = 0;
	}

	fv->resettimo--;
	DP(("fv%d: start1: sts = 0x%x\n", fv->fv_unit, (int)sts));

	/* Even BUD done successfully! */
	if (sts == TR_POC_COMPLETE_OK) {
		u_int addr;
		u_short cmdsts;
		struct tr_init_block ib;
#ifdef FV_CAF
		if (fv->flags&TR_PROMISC) {
			register int i, j;
			MCSEG *mcp;

			for (i = 0; i < NMCSEGS; i++) {
				mcp = &caf[i];
				io->sifadrx = mcp->trg_hi;
				io->sifadr = mcp->trg_lo;
				for (j = 0; j < mcp->len; j++)
					io->sifdat_inc = mcp->src[j];
			}

			if (showconfig)
				printf("fv%d: executing CAF\n",fv->fv_unit);
			io->actl = (io->actl & 0xffbf); 
			DELAY(3*1000*1000);	/* give 3 sec for BUD */
		}
#endif
#ifdef LLC223
		else {
			register int i, j;
			MCSEG *mcp;

			for (i = 0; i < NMCSEGS; i++) {
				mcp = &llc[i];
				io->sifadrx = mcp->trg_hi;
				io->sifadr = mcp->trg_lo;
				for (j = 0; j < mcp->len; j++)
					io->sifdat_inc = mcp->src[j];
			}

			if (showconfig)
				printf("fv%d: executing LLC223\n", fv->fv_unit);
			io->actl = (io->actl & 0xffbf); 
			DELAY(3*1000*1000);	/* give 3 sec for BUD */
		}
#endif
		/* clear counters */
		bzero((char *)&fv->fv_statlog, sizeof(fv->fv_statlog));

		cmdsts = io->sifcmd_stat;
		if (((cmdsts&TR_STAT_INIT) == 0) && !(fv->flags&TR_HARDRESET))
			goto skip_init;
		/* prepare the TMS380 initialization block */
		ib.init_options = TR_INIT_RESERVED_BIT|TR_BURST_SCB_SSB|
			TR_BURST_LIST|TR_BURST_LIST_STATUS|TR_BURST_RCV_DATA|
			TR_BURST_XMIT_DATA;
		if (fv->flags&TR_ONCHIPLLC)
			ib.init_options |= TR_LLC_ENABLE;
		DP(("fv%d: init: opt = %x\n",
			fv->fv_unit, (u_int)ib.init_options));

		ib.cmd_stat_vec = fv->fv_vector;
		ib.xmit_vec = fv->fv_vector;
		ib.rcv_vec = fv->fv_vector;
		ib.ring_stat_vec = fv->fv_vector;
		ib.scb_clear_vec = fv->fv_vector;
		ib.adapter_check_vec = fv->fv_vector;

		/* set receive and transmit burst sizes */
		ib.rcv_burst_size = TR_DATA_BUFFER_SIZE;
		ib.xmit_burst_size = TR_DATA_BUFFER_SIZE;

		/* set max retries for bus and parity errors */
		ib.dma_abort_thresh=(TR_MAX_BUS_ERRORS<<8)|TR_MAX_PARITY_ERRORS;

		/* set SSB and SCB addresses in buffer memory 
 		 * buffer memory starts at address 0 for the TMS380
 		 */
		addr = (u_int)BDMEM(tr_scb, u_int);
		BDINT(ib.scb_addr_hi, addr);

		addr = (u_int)BDMEM(tr_ssb, u_int);
		BDINT(ib.ssb_addr_hi, addr);

		/* write initialization block into TMS380 memory */
		fv_stobdm(io,(u_short)TR_INIT_ADDR, (u_short*)&ib,sizeof(ib));
		io->sifcmd_stat = TR_CMD_INT_ADAPT|TR_CMD_EXECUTE|TR_STAT_INTR;
skip_init:
		fv->fv_state = FV_STATE_INIT;
/* 
 * Don't continue with bringup (especially enabling receives) till 
 * after the ifconfig comes down.
 * Otherwise, this causes miniroot kernel panics because the
 * network is not automatically started, so ipintrq is not initialized
 * and the fv_recv()'s IFQ_LOCK causes a panic in null-lock access.
 */
		if (fv->naddrset)
			fv->reset_tid = cputimeout((void (*)())fvstart2,
					   (caddr_t)fv, TR_INCR_TIMEOUT);
	} else if (fv->resettimo > 0 &&
		  (sts == TR_POC_IN_PROGRESS || sts == TR_NO_RESPONSE)) {
		fv->reset_tid = cputimeout((void (*)())fvstart1,
					   (caddr_t)fv, TR_INCR_TIMEOUT);
	} else {
		printf("fv%d: reset FAILED\n");
		fv->fv_state = FV_STATE_SICK;
		wakeup((caddr_t)&fv->fv_state);
	}
}

/*
 * reset the board
 */
static void
fvreset(struct fv_info *fv, int wf)
{
	time_t wt;
	FVIO *io = fv->FVIO;
	u_char sts = io->vme_status;

	if (fv->reset_tid) {
		untimeout(fv->reset_tid);
		fv->reset_tid = 0;
	}
	fv->flags |= TR_HARDRESET;
#ifdef LLC223
	{
		int i;
		u_int new_mode = io->actl & 0x0108;/* save PSDMA/SINTEN bits */

		DP(("fv%d: chip reset\n", fv->fv_unit));
		io->actl = 0x0080;
		new_mode |= 0x0061;
		for(i=0;i<10;i++);	/* wait a bit (t119 - 14uS min) */
		new_mode |= io->actl & 0x0014;	/* get H/W config bits */
		io->actl = new_mode;
		for(i=0;i<10;i++);
		wt = TR_INCR_TIMEOUT;
	}
#else
	if (((fv->flags&TR_EDTINIT) == 0) && (sts == TR_POC_COMPLETE_OK)) {
		DP(("fv%d: soft reset\n", fv->fv_unit));
		fv->flags &= ~TR_HARDRESET;
		wt = 1;
	} else if (((fv->flags&TR_EDTINIT) == 0) &&
		(sts==TR_NO_RESPONSE || sts == TR_POC_IN_PROGRESS)) {
		DP(("fv%d: skew reset\n", fv->fv_unit));
		wt = 1;
	} else if ((fv->flags&TR_EDTINIT) && (fv->flags&TR_PROMISC)) {
		int i;
		u_int new_mode = io->actl & 0x0108;/* save PSDMA/SINTEN bits */

		DP(("fv%d: chip reset\n", fv->fv_unit));
		io->actl = 0x0080;
		new_mode |= 0x0061;
		for(i=0;i<10;i++);	/* wait a bit (t119 - 14uS min) */
		new_mode |= io->actl & 0x0014;	/* get H/W config bits */
		io->actl = new_mode;
		for(i=0;i<10;i++);
		wt = TR_INCR_TIMEOUT;
	} else {
		DP(("fv%d: hard reset\n", fv->fv_unit));
		io->vme_reset = (u_char)TR_RESET_CODE;
		wt = TR_RESET_TIMEOUT*HZ; /* XXX: FV1600 takes 35sec. */
	}
#endif
	fv->resettimo = 60;	/* give max 1 min */
	if (wf) {
		fv->rtry++;
		fv->reset_tid = cputimeout((void (*)())fvstart1,
					   (caddr_t)fv, wt);
	} else {
		wakeup((caddr_t)&fv->fv_state);
	}
	fv->fv_if.if_timer = 0;		/* turn off watchdog */
	fv->fv_state = FV_STATE_RESET;
}

static struct trlliops fvlliops =
	{ fv_valid_unit, fv_get_sa, (int (*)())fv_lli_output };

/*
 * Probe for a single board and attach if present.
 */
void
if_fvedtinit(struct edt *edtp)
{
	FVIO *io;
	FVMEM *mem;
	TR_MAC_HDR mh;
	struct ifnet *ifp;
	struct fv_info *fv;
	unsigned char unit;
	struct vme_intrs *intp;
#ifndef _IRIX4
	piomap_t *piomap, *memmap;
#endif
#if (DBG_LVL >= DBG_LVL_DRV)
	u_long t1, t2;
	drv_getparm (LBOLT, &t1);
#endif

    /* 1: check unit number */
#ifdef _IRIX4
	if ((intp = edtp->e_intr_info) == 0)
		unit = FV_MAXBD+1;
	else
		unit = intp->v_unit;
#else
	intp = (vme_intrs_t *)edtp->e_bus_info;
	unit = edtp->e_ctlr;
#endif
	if (unit >= FV_MAXBD) {
		printf("fv%u: bad EDT entry\n", unit);
		return;
	}

	fv = &fv_info[unit];
	if (0 != fv->FVIO) {
		printf("fv%u: duplicate EDT entry\n", unit);
		return;
	}

#ifdef _IRIX4
	io = (FVIO*)edtp->e_base2;	/* base2 = SIO */
	fv->fv_vme_adapter = vme_adapter(io);
	mem = (FVMEM*)edtp->e_base;	/* base = EIO */
#else
	IDP(("fv%u: allocating pio map, fv=%x\n", unit, fv));
	fv->fv_vme_adapter = edtp->e_adap;
	piomap = pio_mapalloc(edtp->e_bus_type, fv->fv_vme_adapter,
			      &edtp->e_space[1], PIOMAP_FIXED, "fv");
	if (!piomap) {
		printf("fv%u: PIO map failed\n", unit);
		return;
	}
	IDP(("fv%u: sio map=%x\n",unit,piomap));
	io = (FVIO*)pio_mapaddr(piomap, edtp->e_iobase2);
	IDP(("fv%u: sio(%x) mapped to %x\n",unit,edtp->e_iobase2,io));

	IDP(("fv%u: allocating mem map\n", unit));
	memmap = pio_mapalloc(edtp->e_bus_type, fv->fv_vme_adapter,
			      &edtp->e_space[0], PIOMAP_FIXED, "fv");
	if (!memmap) {
		printf("fv%u: MEM map failed\n", unit);
		return;
	}
	IDP(("fv%u: eio map=%x\n",unit,memmap));
	mem = (FVMEM*)pio_mapaddr(memmap, edtp->e_iobase);
	IDP(("fv%u: eio(%x) mapped to %x\n",unit,edtp->e_iobase, mem));
#endif /* _IRIX4 */

    /* 2: Probe */
#ifdef EVEREST
	/* Since VMECC resets all VME devices, should give enough
	 * time for the board to settle down.
	 */
	DELAY(20*1000*1000);
#endif
	if (badaddr(mem, sizeof(int))) {
		DP(("fv%d: MEM not seen\n", unit));
		return;
	} else {
		DP(("fv%d: MEM SEEN\n", unit));
	}

	if (badaddr(&io->vme_status, sizeof(char))) {
#ifndef _IRIX4
		pio_mapfree(piomap);
		pio_mapfree(memmap);
#endif
		printf("fv%d: missing\n", unit);
		return;
	}
	if (showconfig)
		printf("fv%d: present\n", unit);

#ifndef _IRIX4
	if (!intp->v_vec) {
		IDP(("fv%u: allocating IVEC\n", unit));
		intp->v_vec = vme_ivec_alloc(fv->fv_vme_adapter);
		if (!intp->v_vec) {
			IDP(("fv%u: waisting NULL-IVEC\n", unit));
			intp->v_vec = vme_ivec_alloc(fv->fv_vme_adapter);
			if (!intp->v_vec) {
				IDP(("fv%u: COMMOM GIMMEA BREAK NULL-IVEC\n", unit));
				return;
			}
		}
	}
	IDP(("fv%u: IVEC=%x\n", unit, intp->v_vec));

	if (intp->v_vec == (unsigned char)-1) {
		printf("fv%u: no interrupt vector\n", unit);
		return;
	}
	vme_ivec_set(fv->fv_vme_adapter, intp->v_vec, if_fvintr, unit);
	IDP(("fv%u: IVEC set!\n", unit));
#endif /* !_IRIX4 */


	/* setup PRIVATE data.*/
	/* TBD: allocate mcast filter table.
	 *	Probably, ALLMULTI(via ffffffff) should be used and
	 *	locally calculate correct filter.
	 */

	/* set up the fv_info structure with the VME shared memory addresses.
	 *	base = A32 space for data buffers, etc.
	 *	base2 = A16 data space for board registers
	 */
	fv->fv_mem = mem;		/* board is here */
	fv->FVIO = io;			/* registers are here */
	fv->fv_vector = intp->v_vec;
	fv->fv_brl = intp->v_brl;
	fv->addrset = 0;
	fv->naddrset = 0;

#ifdef HOSTLLC
	fv->flags = TR_16_MBIT;
#else
	fv->flags = TR_ONCHIPLLC|TR_16_MBIT;
#endif
	bzero((caddr_t)&fv->tr_fcn_addr,sizeof(fv->tr_fcn_addr));
	bzero((caddr_t)&fv->tr_grp_addr,sizeof(fv->tr_grp_addr));

	/* set initial default invent */
	add_to_inventory(INV_NETWORK, INV_NET_TOKEN, INV_TOKEN_FV, unit, 1);

	/* setup Broadcast address */
	if (fv_batype != 1 && fv_batype != 2) {
		if (showconfig)
		    printf("fv%d: broadcast address set to 0xC000FFFFFFFF\n",
			    unit);
		fv_batype = 1;
	}

	/* prepare for ATTACH */
	ifp = &fv->fv_if;
	ifp->if_unit = unit;
	ifp->if_name = "fv";		/* create ('attach') the interface */
	ifp->if_type = IFT_ISO88025;
	ifp->if_mtu = min(fv_mtu, TRMTU_16M);
	ifp->if_flags = IFF_BROADCAST|IFF_MULTICAST|IFF_NOTRAILERS|IFF_ALLCAST;
	ifp->if_output = if_fvoutput;
	ifp->if_ioctl = (int (*)(struct ifnet*, int, void*))if_fvioctl;
	fv_setnullsri(fv);

	/* ATTACH interface */
	if_attach(ifp);

	/* start the board ASAP */ 
	fvreset(fv, 1);

	rawif_attach(&fv->fv_rawif, ifp,
		     (caddr_t)fv->fv_enaddr, (caddr_t)etherbroadcastaddr,
		     sizeof(fv->fv_enaddr), sizeof(mh),
		     ((__psint_t)((__psunsigned_t)mh.t_mac_sa - (__psunsigned_t)&mh)),
		     ((__psint_t)((__psunsigned_t)mh.t_mac_da - (__psunsigned_t)&mh)));
	(void)tr_lli_register(&fvlliops);
#if (DBG_LVL >= DBG_LVL_DRV)
	drv_getparm (LBOLT, &t2);
	if (ifp->if_unit == 0)
		fv_edt_time0 = drv_hztousec((clock_t)(t2-t1));
	else if (ifp->if_unit == 1)
		fv_edt_time1 = drv_hztousec((clock_t)(t2-t1));
#endif

}

/*----------------------------------------------------------------------*
 *	Issue a command to the Formation board				*
 *		generic routine used all over the driver to issue	*
 *		a variety of commands to the board.			*
 *----------------------------------------------------------------------*/
static int
fvIssueCmd(struct fv_info *fv, int cmd, u_int addr)
{
	int error;
	FVMEM *mem = fv->fv_mem;

/*	DP(("fvIssueCmd: cmd=%x, addr=%x\n", cmd, addr)); */
	if ((error = fv_getscb(fv)) == 0) {
		mem->tr_scb.scb_cmd = cmd;
		BDINT(mem->tr_scb.scb_parm1, addr);
		fv->FVIO->sifcmd_stat = TR_CMD_INT_ADAPT | TR_CMD_EXECUTE | 
			TR_CMD_SCB_REQUEST | TR_STAT_INTR;
	}
	return(error);
}

/*
 * Setup xmit/recv descriptors
 */
static void
fv_setrbuf(struct fv_info *fv)
{
	int i, j;
	u_int bda;
	volatile struct tr_rcv_list *rcvlist;
	volatile struct tr_rcv_list *rcvlistnext;
	FVMEM *mem = fv->fv_mem;
	volatile struct tr_data_buf *dbuf = mem->tr_data_buf;

	/* set up the receive lists */
	fv->n_free_rcvlist = TR_RCV_LISTS;
	rcvlist = rcvlistnext =  mem->fv_rlist;
	fv->rcvlist_first = fv->rcvlist_free = rcvlist;
	for (i = 0; i < TR_RCV_LISTS; i++, rcvlist++) {
		rcvlistnext = TR_NEXT_RCVLIST(fv, rcvlistnext, mem);
		bda = (u_int)((u_long)rcvlistnext - (u_long)mem);
		BDINT(rcvlist->rcv_fwd_high, bda);
		rcvlist->rcv_cstat = 0;
		for (j = 0; j < TR_IOB_HEADERS; j++, dbuf++) {
			bda = (u_int)((u_long)dbuf - (u_long)mem);
			BDINT(rcvlist->rcv_iobh[j].address_high, bda);
		}
	}
	(void)fv_get_rcvlist(fv,
			TR_RCV_LISTS*TR_IOB_HEADERS*TR_DATA_BUFFER_SIZE,1);
}
static void
fv_setxbuf(struct fv_info *fv)
{
	int i, j;
	u_int bda;
	volatile struct tr_xmit_list *xmitlist;
	volatile struct tr_xmit_list *xmitlistnext;
	FVMEM *mem = fv->fv_mem;
	volatile struct tr_data_buf *dbuf;

	/* set up the transmit list. */
	dbuf = &mem->tr_data_buf[TR_RCV_LISTS*TR_IOB_HEADERS];
	fv->xmitlist_first = 0;
	fv->xmitlist_last = 0;
	fv->n_free_xmitlist = TR_XMIT_LISTS;
	xmitlist = xmitlistnext = fv->xmitlist_free = mem->fv_xlist;
	for (i = 0; i < TR_XMIT_LISTS; i++, xmitlist++) {
		xmitlistnext = TR_NEXT_XMITLIST(fv, xmitlistnext, mem);
		bda = (u_int)((u_long)xmitlistnext - (u_long)mem);
		BDINT(xmitlist->xmit_fwd_high, bda);
		xmitlist->xmit_cstat = 0;
		for (j = 0; j < TR_IOB_HEADERS; j++, dbuf++) {
			bda = (u_int)((u_long)dbuf - (u_long)mem);
			BDINT(xmitlist->xmit_iobh[j].address_high, bda);
		}
	}
}

/*----------------------------------------------------------------------*
 *	Setup open block  to initialize the token-ring board.		*
 *----------------------------------------------------------------------*/
static void
tr_format_open_block(struct fv_info *fv)
{
	u_int addr;
	FVMEM *mem = fv->fv_mem;
	volatile struct tr_open_block *fvob = &mem->open_block;

	fv->fv_openop = TR_PAD_ROUTE_FIELD;
	if (fv->flags&TR_ONCHIPLLC)
		fv->fv_openop |= TR_HOST_I_FRAME_XMIT;
	DP(("fv%d: open: opt = %x\n", fv->fv_unit,(u_int)fv->fv_openop));

	fvob->open_options = fv->fv_openop;
	bcopy(fv->fv_enaddr, (void *)fvob->node_address, sizeof(fv->fv_enaddr));
	DP(("fv%d open: node address %s\n",
			fv->fv_unit, ether_sprintf(fvob->node_address)));
	fvob->group_address.a[0] = htons(fv->tr_grp_addr.a[0]|0x8000);
	fvob->group_address.a[1] = htons(fv->tr_grp_addr.a[1]);
	fvob->functional_address.a[0] = htons(fv->tr_fcn_addr.a[0]&~0x8000);
	fvob->functional_address.a[1] = htons(fv->tr_fcn_addr.a[1]);

	/* set receive and transmit list sizes (don't include padding) */
	fvob->receive_list_size = TR_LIST_SIZE - TR_RECEIVE_LIST_PAD;
	fvob->transmit_list_size = TR_LIST_SIZE -
				TR_TRANSMIT_LIST_PAD - TR_XMIT_LLC_SIZE;
	DP(("fv%d: rcv list size=%d, xmit list size=%d\n", fv->fv_unit,
		fvob->receive_list_size,fvob->transmit_list_size));

	/* set internal buffer size for the TMS380 */
	fvob->buffer_size = TR_TMS380_BUFFER_SIZE;
	fvob->reserved[0] = fvob->reserved[1] = 0;

	/* min and max numbers of internal xmit bufs */
	fvob->xmit_buf_min = RUP(fv->fv_if.if_mtu,(TR_DATA_BUFFER_SIZE-8));
	fvob->xmit_buf_max = fvob->xmit_buf_min*8;

	/* set product id */
	bcopy(prodid, fv->pid, sizeof(fv->pid));
	bcopy(fv->fv_enaddr,&fv->pid[12],sizeof(fv->fv_enaddr));
	VMEOUT(fv->pid, mem->tr_product_id.id, sizeof(fv->pid));

/*	addr = (u_int)((__psunsigned_t)&mem->tr_product_id - (__psunsigned_t)&mem->tr_scb); */
	addr = BDMEM(tr_product_id, u_int);
	BDINT(fvob->product_id_address_hi, addr);

	fvob->sap_max = TR_NSAP;	/* number of SAP's supported */
	fvob->station_max = TR_NSTATION;/* set default number of stations */

	/* indicate that group SAP's are not supported */
	fvob->gsap_max = 0;
	fvob->gsap_member_max = 0;

	/* use default timers */
	fvob->timer_t1_1 = tr_timer_t1_1;
	fvob->timer_t2_1 = tr_timer_t2_1;
	fvob->timer_ti_1 = tr_timer_ti_1;
	fvob->timer_t1_2 = tr_timer_t1_2;
	fvob->timer_t2_2 = tr_timer_t2_2;
	fvob->timer_ti_2 = tr_timer_ti_2;

	/* set max frame size */
	fvob->max_frame_size = fv->fv_if.if_mtu+sizeof(TR_MAC_HDR);
}

/*
 * fvsend:
 */
static int
fvsend(caddr_t packet, struct fv_info *fv, u_short ftype, u_short station_id,
		u_short	sap, u_short packet_type, register int frame_len,
		u_char correlator, int hdrlen)
{
	char *cp;
	int n, nlist;
	struct mbuf *m0;
	TR_MAC_HDR *mh;
	volatile struct tr_data_buf *dparam;
	register volatile struct tr_xmit_list *xmitlist;
	TR_STATUS *trs = &fv->fv_statlog;

	int rlen = 0;
	int nbuf = 0;
	int error = 0;
	int index = 0;
	mblk_t *s0, *stofree = 0;
	FVIO *io = fv->FVIO;
	FVMEM *mem = fv->fv_mem;

	ASSERT(packet != 0);
	if (fv->fv_state != FV_STATE_OK)
		return(ENETDOWN);

	if (fv->xmitlist_first != 0) {
		while (fv->xmitlist_first != fv->xmitlist_free) {
			if (fv->xmitlist_first->xmit_cstat&TR_XMITL_VALID)
				break;
			fv->xmitlist_first =
				fv_free_xmitlist(fv,fv->xmitlist_first);
		}
	}
	if (packet_type != TR_SNA_PACKET) {
		struct mbuf *m1;
		m0 = (struct mbuf*)packet;
		mh = mtod(m0, TR_MAC_HDR*);
		if (mh->t_mac_sa[0] & 0x80) {
			rlen = (mh->t_mac_rii&TR_RIF_LENGTH) >> 8;
			if (rlen == 0)
				mh->t_mac_sa[0] &= ~0x80;
		}
		for (m1 = m0; m1; m1 = m1->m_next) {
			if (m1->m_len == 0)
				continue;
			nbuf += RUP(m1->m_len,TR_DATA_BUFFER_SIZE);
			frame_len += m1->m_len;
		}
#ifdef FV_CAF
		if (RAWIF_SNOOPING(&fv->fv_rawif)) {
			TR_MAC_HDR *msh;
			struct mbuf *ms;
			int totlen, dupoff, hdroff;
			int pad = 2;
			struct rawif *rif = &fv->fv_rawif;
			int hlen = sizeof(TR_MAC)+hdrlen+sizeof(LLC1)+sizeof(SNAP);

			if ((ms=m_get(M_DONTWAIT,MT_DATA))==0) {
				goto ss_drop;
			}
			hdroff = TRPAD;
			totlen = frame_len;
			dupoff = m_datacopy(m0, 0, MIN(totlen, MLEN-TRPAD),
					mtod(ms, caddr_t)+hdroff);
			totlen -= dupoff;
			ms->m_len = dupoff+hdroff;
			if (totlen > 0) {
				ms->m_next=m_copy(m0,dupoff,totlen);
				if (ms->m_next == 0) {
					m_free(ms);
					goto ss_drop;
				}
			}
			IF_INITHEADER(mtod(ms, char*),&fv->fv_if,TRPAD+hlen);
			msh = (TR_MAC_HDR*)(mtod(ms,char*)+TRPAD);
			rif->rif_hdrlen = hlen;
			rif->rif_padhdrlen = pad+hlen;
			rif->rif_hdrpad = pad;
			rif->rif_hdrgrains=rif->rif_padhdrlen>>RAW_ALIGNSHIFT;
			snoop_input(rif,SN_PROMISC,(char*)msh,
					ms,frame_len-hlen);
ss_drop:;
		}
#endif
	} else {
		mblk_t *s1;
		int tmp, off;

		if (ftype == TR_FTYPE_I_FRAME) {
			if ((s0 = dupmsg((mblk_t*)packet)) == 0)
				return(ENOBUFS);
			stofree = s0;
			goto skip_hdrchk;
		}
		s0 = (mblk_t*)packet;
		mh = (TR_MAC_HDR*)s0->b_rptr;
		/* adjust 18 bytes pad */
		if (mh->t_mac_sa[0] & 0x80) {
			rlen = (mh->t_mac_rii&TR_RIF_LENGTH) >> 8;
			off = sizeof(TR_RII) - rlen;
			if (off > 0) {
			    bcopy(s0->b_rptr, s0->b_rptr+off, sizeof(*mh)-off);
			    s0->b_rptr += off;
			    frame_len -= off;
			}
			mh = (TR_MAC_HDR*)s0->b_rptr;
			if (rlen == 0)
				mh->t_mac_sa[0] &= ~0x80;
		}
skip_hdrchk:
		tmp = frame_len;
		for (s1 = s0; s1; s1 = s1->b_cont) {
			n = (u_long)s1->b_wptr-(u_long)s1->b_rptr;
			nbuf += RUP(n,TR_DATA_BUFFER_SIZE);
			tmp -= n;
		}
		if (tmp > 0) {
			LP(("fv%d: send: stream buf %d bytes short\n",
					fv->fv_unit, (frame_len-tmp)));
			error = ENOBUFS; goto xret;
		}
	}
	nlist = RUP(nbuf,TR_IOB_HEADERS);
	if (nlist >= fv->n_free_xmitlist) {
		/*
		 * The xmit algorithm maps 1 mbuf to 1 xmit buffer,
		 * probably to avoid odd offset transfers, but
		 * check for the case where the data is so fragmented
		 * that the #mbufs > #xmit bufs, this data should
		 * be packed.
		 */
		if (nlist > TR_XMIT_LISTS/2) {
			nbuf = RUP(frame_len, TR_DATA_BUFFER_SIZE);
			nlist = RUP(nbuf,TR_IOB_HEADERS);
			if (nlist < fv->n_free_xmitlist) {
				if (ftype == TR_FTYPE_I_FRAME && stofree != 0)
					freemsg(stofree);
				return (fvpacksend(packet,fv,ftype,station_id,
						   sap, packet_type,frame_len,
						   correlator,hdrlen,rlen,mh));
			}
		}
		DP(("fv%d: xmit list not available\n", fv->fv_unit));
		error = ENOBUFS; goto xret;
	}

	fv->fv_if.if_opackets++;
	fv->fv_if.if_obytes += frame_len;

	xmitlist = fv->xmitlist_free; CHKXL(xmitlist);
	fv->xmitlist_free = TR_NEXT_XMITLIST(fv, xmitlist, mem);
	fv->n_free_xmitlist--;
	fv->xmitlist_last = xmitlist;
	if (fv->xmitlist_first == NULL)
		fv->xmitlist_first = xmitlist;

	QDBGHW(frame_len, trs->x_maxsize);
	QDBGHW(nlist,trs->x_maxlists);
	QDBGHW(TR_XMIT_LISTS-fv->n_free_xmitlist,trs->xq_hiwat);

	/* initialize first transmit list */
	xmitlist->xmit_cstat = ftype|TR_XMITL_START_FRAME;
	xmitlist->xmit_header_size = sizeof(TR_MAC)+hdrlen;
	xmitlist->xmit_frame_size = frame_len;
	xmitlist->xmit_station_id = station_id;
	xmitlist->xmit_remote_sap = sap;
	if (ftype == TR_FTYPE_I_FRAME)
		xmitlist->xmit_frame_corl = correlator;
	else if (mh->t_mac_sa[0] & 0x80)
		xmitlist->xmit_header_size = sizeof(TR_MAC)+rlen;

	/* setup transmit list */
	while (frame_len > 0) {
		/* get next free data buffer */
		dparam = IOBP(xmitlist->xmit_iobh[index], struct tr_data_buf*);
		CHKDB(dparam);

		/* determine dbuf size now and copy into board */
		if (packet_type != TR_SNA_PACKET) {
			cp = mtod(m0,char*);
			if (m0->m_len <= TR_DATA_BUFFER_SIZE) {
				n = m0->m_len;
				m0 = m0->m_next;
				while (m0 && m0->m_len == 0)
					m0 = m0->m_next;
			} else {
				n = TR_DATA_BUFFER_SIZE;
				m0->m_len -= TR_DATA_BUFFER_SIZE;
				m0->m_off += TR_DATA_BUFFER_SIZE;
			}
		} else {
			cp = (char*)s0->b_rptr;
			n = (u_long)s0->b_wptr-(u_long)s0->b_rptr;
			if (n <= TR_DATA_BUFFER_SIZE) {
				s0 = s0->b_cont;
				while (s0 && 
				    ((u_long)s0->b_wptr-(u_long)s0->b_rptr)==0)
					s0 = s0->b_cont;
			} else {
				n = TR_DATA_BUFFER_SIZE;
				s0->b_rptr += TR_DATA_BUFFER_SIZE;
			}
		}
		if (n&1)
			VMEOUT(cp,(char*)dparam,n+1);
		else
			VMEOUT(cp,(char*)dparam,n);
		frame_len -= n;
		if (frame_len <= 0) {
	        	xmitlist->xmit_iobh[index].data_count = n;
			break;
		}
	    	xmitlist->xmit_iobh[index].data_count = n|TR_NOT_LAST_IOB_HDR;
		if (++index == TR_IOB_HEADERS) {
			index = 0;
			xmitlist = fv->xmitlist_free;
			fv->xmitlist_free = TR_NEXT_XMITLIST(fv,xmitlist,mem);
			CHKXL(xmitlist);
			fv->n_free_xmitlist--;
			xmitlist->xmit_cstat = ftype|TR_XMITL_VALID;
		}
	}

	/* set end of frame bits in last frame status field */
	xmitlist->xmit_cstat |= TR_XMITL_END_FRAME;
	fv->xmitlist_last->xmit_cstat |= TR_XMITL_VALID;
	io->sifcmd_stat=TR_CMD_INT_ADAPT|TR_CMD_XMIT_VALID|TR_STAT_INTR;

xret:
	if (ftype == TR_FTYPE_I_FRAME && stofree != 0) {
		freemsg(stofree);
	}
	return(error);
}

/*
 * special transmit routine that packs data into transmit buffers
 */
static int
fvpacksend(caddr_t packet, struct fv_info *fv, u_short ftype, 
	   u_short station_id, u_short sap, u_short packet_type,
	   register int frame_len, u_char correlator, int hdrlen,
	   int rlen, TR_MAC_HDR *mh)
{
	char *buf;
	struct mbuf *m0;
	mblk_t * mp;
	volatile struct tr_data_buf *dparam;
	register volatile struct tr_xmit_list *xmitlist;
	TR_STATUS *trs = &fv->fv_statlog;

	int n;
	register char *src, *dst;
	int index = 0;
	FVIO *io = fv->FVIO;
	FVMEM *mem = fv->fv_mem;
	int buflen = frame_len;

	DP(("fvpacksend() called.\n"));
	if (!(buf = kmem_alloc(buflen, KM_NOSLEEP)))
		return ENOMEM;

	fv->fv_if.if_opackets++;
	fv->fv_if.if_obytes += frame_len;

	xmitlist = fv->xmitlist_free; CHKXL(xmitlist);
	fv->xmitlist_free = TR_NEXT_XMITLIST(fv, xmitlist, mem);
	fv->n_free_xmitlist--;
	fv->xmitlist_last = xmitlist;
	if (fv->xmitlist_first == NULL)
		fv->xmitlist_first = xmitlist;

	QDBGHW(frame_len, trs->x_maxsize);
	QDBGHW(TR_XMIT_LISTS-fv->n_free_xmitlist,trs->xq_hiwat);

	/* initialize first transmit list */
	xmitlist->xmit_cstat = ftype|TR_XMITL_START_FRAME;
	xmitlist->xmit_header_size = sizeof(TR_MAC)+hdrlen;
	xmitlist->xmit_frame_size = frame_len;
	xmitlist->xmit_station_id = station_id;
	xmitlist->xmit_remote_sap = sap;
	if (ftype == TR_FTYPE_I_FRAME)
		xmitlist->xmit_frame_corl = correlator;
	else if (mh->t_mac_sa[0] & 0x80)
		xmitlist->xmit_header_size = sizeof(TR_MAC)+rlen;

	/* First use bcopy to pack data into the kmem_alloc()ed
	 * buffer, then send down to board. This avoids single
	 * byte moves down to the board to compensate for odd
	 * offsets.
	 */
	dst = buf;
	if (packet_type != TR_SNA_PACKET) {
		m0 = (struct mbuf *) packet;
		while (m0 && (frame_len > 0)) {
			if ((n = m0->m_len) > 0) {
				src  = mtod(m0,char*);
				bcopy (src, dst, n);
				frame_len -= n;
				dst += n;
			}
			m0 = m0->m_next;
		}
	} else {
		mp = (mblk_t *)packet;	    
		while (mp && (frame_len > 0)) {
			n = (u_long)mp->b_wptr - (u_long)mp->b_rptr;
			if (n > 0) {
				src = (char *) mp->b_rptr;
				bcopy (src, dst, n);
				dst += n;
				frame_len -= n;
			}
			mp = mp->b_cont;
		}
	} /* (packet_type != TR_SNA_PACKET) */
	ASSERT (frame_len == 0);

	/* Now transfer from buf to board */
	frame_len = dst - buf;
	src = buf;
	while (frame_len > 0) {
		/* get next free data buffer */
		dparam = IOBP(xmitlist->xmit_iobh[index], struct tr_data_buf*);
		CHKDB(dparam);
		if (frame_len > TR_DATA_BUFFER_SIZE)
			n = TR_DATA_BUFFER_SIZE;
		else
			n = frame_len;
		if (n&1)
			VMEOUT(src,(char*)dparam,n+1);
		else
			VMEOUT(src,(char*)dparam,n);
		frame_len -= n;
		src += n;
		if (frame_len <= 0) {
	        	xmitlist->xmit_iobh[index].data_count = n;
			break;
		}
	    	xmitlist->xmit_iobh[index].data_count = n|TR_NOT_LAST_IOB_HDR;
		if (++index == TR_IOB_HEADERS) {
			index = 0;
			xmitlist = fv->xmitlist_free;
			fv->xmitlist_free = TR_NEXT_XMITLIST(fv,xmitlist,mem);
			CHKXL(xmitlist);
			fv->n_free_xmitlist--;
			xmitlist->xmit_cstat = ftype|TR_XMITL_VALID;
		}
	}

	/* set end of frame bits in last frame status field */
	xmitlist->xmit_cstat |= TR_XMITL_END_FRAME;
	fv->xmitlist_last->xmit_cstat |= TR_XMITL_VALID;
	io->sifcmd_stat=TR_CMD_INT_ADAPT|TR_CMD_XMIT_VALID|TR_STAT_INTR;

	kmem_free(buf, buflen);
	return 0;
}

/*
 * Allocate receive list
 */
static volatile struct tr_rcv_list *
fv_get_rcvlist(struct fv_info *fv, int len, int chk)
{
	register int nlist;
	register int index;
	register volatile struct tr_rcv_list *rcvlist;
	register FVMEM *mem = fv->fv_mem;

	nlist = RUP(len, (TR_DATA_BUFFER_SIZE*TR_IOB_HEADERS));
	QDBGHW(nlist,fv->fv_statlog.r_maxlists);
	if (chk) {
		if (nlist > fv->n_free_rcvlist) {
			DP(("fv%d: no rcvlist available\n", fv->fv_unit));
			return(0);
		}
		fv->n_free_rcvlist -= nlist;
	}
	QDBGHW(nlist,fv->fv_statlog.rq_hiwat);

	for (; nlist > 0; nlist--) {
		rcvlist = fv->rcvlist_free;
		fv->rcvlist_free = TR_NEXT_RCVLIST(fv, rcvlist, mem);
		rcvlist->rcv_cstat = TR_RCVL_VALID|TR_RCVL_FRAME_INT;

		for (index = 0; index < TR_IOB_HEADERS; index++) {
			rcvlist->rcv_iobh[index].data_count =
				(TR_DATA_BUFFER_SIZE|TR_NOT_LAST_IOB_HDR);
		}
	}
	return(fv->rcvlist_free);
}

/*
 * Close the board
 */
static void
fv_wakeupclose(struct fv_info *fv)
{
	untimeout(fv->reset_tid);
	fv->reset_tid = 0;
	wakeup((caddr_t)&fv->cmd_Status[TR_CMD_CLOSE]);
}

static int
fv_close(struct fv_info *fv, int restart)
{
	int error = 0;
	FVIO *io = fv->FVIO;
	FVMEM *mem = fv->fv_mem;

	DP(("fv%d: close%\n", fv->fv_unit));
	ASSERT(IFNET_ISLOCKED(&fv->fv_if));

	if (fv->fv_state != FV_STATE_OK)
		goto close_ret;

	while ((fv->cmd_Flags[TR_CMD_CLOSE]&CMD_BUSY) != 0) {
		fv->cmd_Flags[TR_CMD_CLOSE] |= CMD_PENDING;
		IFNET_UNLOCKNOSPL(&fv->fv_if);
		sleep((caddr_t)&fv->cmd_Flags[TR_CMD_CLOSE],PZERO|PCATCH);
		IFNET_LOCKNOSPL(&fv->fv_if);
	}
	fv->cmd_Flags[TR_CMD_CLOSE] |= CMD_BUSY;

	if (error = fv_getscb(fv)) {
		fv->cmd_Flags[TR_CMD_CLOSE] &= ~CMD_BUSY;
		error = EIO; goto close_ret;
	}
	fv->cmd_Status[TR_CMD_CLOSE] = EIO;
	fv->reset_tid = cputimeout(fv_wakeupclose, (caddr_t)fv, 
				5*TR_INCR_TIMEOUT);

	/* set up scb (command block) to board to close */
	mem->tr_scb.scb_cmd = TR_CMD_CLOSE;
	mem->tr_scb.scb_parm1 = 0;
	mem->tr_scb.scb_parm2 = 0;

	/* issue close command to board */
	io->sifcmd_stat = TR_CMD_INT_ADAPT | TR_CMD_EXECUTE | 
		        TR_CMD_SCB_REQUEST | TR_STAT_INTR;

	IFNET_UNLOCKNOSPL(&fv->fv_if);
	sleep((caddr_t)&fv->cmd_Status[TR_CMD_CLOSE], PZERO|PCATCH);
	IFNET_LOCKNOSPL(&fv->fv_if);
	if (fv->cmd_Status[TR_CMD_CLOSE] == 0) {
		fv->fv_state = FV_STATE_CLOSE;
		fv->fv_if.if_flags &= ~(IFF_UP|IFF_RUNNING);
		if (restart) {
			fv->inittimo = 0;
			fvstart2(fv);
		}
	} else {
		fv->fv_state = FV_STATE_SICK;
		error = fv->cmd_Status[TR_CMD_CLOSE];
	}
	fv->cmd_Flags[TR_CMD_CLOSE] &= ~CMD_BUSY;

close_ret:
	return(error);
}

static int
fv_valid_unit(int unit)
{
	if (unit >= 0 && unit < FV_MAXBD) {
		return(1);
	}
	return(0);
}

static char *
fv_get_sa(int unit)
{
	struct fv_info *fv;

	if (unit >= 0 && unit < FV_MAXBD) {
		fv = &fv_info[unit];
		return((char *)fv->tr_hdr.t_mac_sa);
	}
	return((char *)0);
}

/*----------------------------------------------------------------------*
 * 	fv_lli_output							*
 *									*
 *	 	Interface to token-ring driver from LLI module		*
 *		and the rest of the SNA protocol stack			*
 *									*
 *		returns -1 if error occurs				*
 *		or 0 if successful					*
 *----------------------------------------------------------------------*/
static int
fv_lli_output(u_short unit, SCB *scb)
{
	char *addr;
	FVMEM *mem;
	caddr_t	pblk;
	mblk_t *em_ptr;
	struct fv_info *fv;
	TR_XMIT_PARMS *xp;
    	TR_OPEN_STATION_BLOCK *opn_blk;
	u_short	error = 0;
	int s = splimp();

	/* ensure unit number is valid */
	if (unit >= FV_MAXBD) {
		splx(s); return(0);
	}

	LP(("fv_lli_output: req = %d\n", scb->scb_cmd));
	fv = &fv_info[unit];
	if (fv->fv_state != FV_STATE_OK) {
		LP(("fv_lli_output: board is not operational\n"));
		splx(s); return(0);
	}

	switch (scb->scb_cmd) {
	case TR_CMD_TRANSMIT:
		/* Here, the scb will point to a transmit parameter
		 * block (on the stack). In turn, the transmit parameter
		 * block will point to xmit_data, which will be an mblk.
		 */

		HTINT(xp, scb->scb_parm1);
/*		xp = HTMEM(xp, TR_XMIT_PARMS *); */
		em_ptr = (mblk_t *)xp->xmit_data;
		if (xp->frame_type == TR_FTYPE_I_FRAME) {
#ifdef IFRMDBG
			char *cp;

			fvnxtcorel += 2;
			fvnxtcorel &= 0xff;
			cp = xp->xmit_data->b_rptr;
			if (cp[0]==0 && cp[1]==0 && cp[2]==0 && cp[3]==0) {
				printf("lli_output: BAD Iframe\n");
				fv_hexdump(cp, 32);
			}
#endif
#ifdef IWAITMSG
			if (babble) {
				printf("got iframe from lli\n");
				babble--;
			}
#endif
			QDBGUP(fvifx.tot,1);
			error = fv_xmit_iframe(fv, xp, 0);
#ifdef QDBG
			if (error) {
				QDBGUP(fvifx.reject,1);
			}
#endif
			break;
		}
		LP(("fv_lli_output(xmit): remote sap = %x, stn id = %x\n",
				xp->remote_sap, xp->station_id));
		error = fvsend((caddr_t)em_ptr, fv, xp->frame_type, 
			xp->station_id, xp->remote_sap, TR_SNA_PACKET,
			xp->frame_size, 0, 0);
		break;

	case TR_CMD_LLC_RESET:
		error = tr_llc_reset(fv, scb->scb_parm1);
		if (scb->scb_parm1 != 0)
			break;

		fv->cmd_Flags[TR_CMD_OPEN_SAP] |= CMD_BUSY;
		fv->fv_state = FV_STATE_OPENSAP;
		error = fv_open_ip_sap(fv);
		break;

	case TR_CMD_OPEN_SAP:
		HTINT(pblk, scb->scb_parm1);
		/* pblk = HTMEM(pblk, caddr_t); */
		error = fv_open_sap(fv, (TR_OPEN_SAP_BLOCK*)pblk);
		break;

	case TR_CMD_CLOSE_SAP:
		error = fv_close_sap(fv, scb->scb_parm1);
		break;

	case TR_CMD_OPEN_STATION: {
		u_int disp;
		/* need to copy the remote node address into shared vme
	  	 * memory so the board can see it, too.
		 */
		mem = fv->fv_mem;
		HTINT(pblk, scb->scb_parm1);
		/* pblk = HTMEM(pblk, caddr_t); */
		opn_blk = (TR_OPEN_STATION_BLOCK *)pblk;
		HTINT(addr, opn_blk->rnode_addr_high);
		/* addr = HTMEM(addr, char *); */
		VMEOUT(addr, mem->tr_reserved, TR_MAC_ADDR_SIZE);
LP(("lli_output: open_stn: sid = 0x%x, rsap = 0x%x, option = 0x%x, *addr = %x:%x:%x:%x:%x:%x\n", 
			opn_blk->station_id,
			opn_blk->rsap_value,
			opn_blk->station_options,
			mem->tr_reserved[0],mem->tr_reserved[1], 
			mem->tr_reserved[2],mem->tr_reserved[3],
			mem->tr_reserved[4],mem->tr_reserved[5]));

		disp = (u_int)(((__psunsigned_t)&mem->tr_reserved[0])-(__psunsigned_t)mem);
		BDINT(opn_blk->rnode_addr_high, disp);
		error = fv_open_station(fv, opn_blk);
		break;
	}

	case TR_CMD_CLOSE_STATION:
		error = fv_close_station(fv, scb->scb_parm1);
		break;

	case TR_CMD_CONNECT_STATION:
		HTINT(pblk, scb->scb_parm1);
		/* pblk = HTMEM(pblk, caddr_t); */
		error = fv_connect_station(fv, (TR_CONNECT_STN_BLK *)pblk);
		break;

	case TR_CMD_LLC_STATS:
		break;

	default:
		splx(s); return(0);
	}

	if (error) {
		LP(("fv_lli_output: error = %x \n", error));
		splx(s); return(0);
	}
	LP(("fv_lli_output: successful completion\n"));
	splx(s); return(1);
}
 
#ifdef IFRMDBG
static void
stash_ifrm(IFRAMES *ifrm, u_int corel)
{
	char *cp;
	mblk_t *mb;

	if (ifrm == 0 || corel >= 255) {
		printf("Iframe Internel error, ptr=%x, corel=%x\n",ifrm,corel);
		return;
	}

	if (fv_scorel && (corel != fvnxtcorel)) {
		printf("Iframe corel out of sync. exp=%x, actual=%x\n",
			fvnxtcorel, corel);
		fv_scorel = 0;
	} else if (!fv_scorel && (corel == fvnxtcorel)) {
		printf("Iframe corel back int sync at %x\n", corel);
		fv_scorel = 1;
	}

	cp = (char*)&fvifr0[corel];
	bcopy((char*)ifrm,cp,sizeof(*ifrm));

	if ((mb=ifrm->xmit_parms.xmit_data)==0) {
		printf("No Iframe mblk for corel=%d\n",(int)corel);
		return;
	}
	cp = (char*)&fvmb0[corel];
	bcopy((char*)mb, cp, sizeof(*mb));

	if (mb->b_datap == 0) {
		printf("No Iframe datap for corel=%d\n",(int)corel);
		return;
	}
	cp = (char*)&fvdp0[corel];
	bcopy((char*)mb->b_datap, cp, sizeof(struct datab));

	if (mb->b_rptr == 0) {
		printf("No rptr for corel=%d\n",(int)corel);
		return;
	}

	cp = &fvmd0[corel][0];
	bcopy(mb->b_rptr,cp, 32);
	if (cp[0]==0 && cp[1]==0 && cp[2]==0 && cp[3]==0) {
		printf("Already BAD Iframe for corel=%d\n", (int)corel);
		fv_hexdump((char*)mb, sizeof(*mb));
		fv_hexdump((char*)mb->b_datap, 16);
		printf("bad data:\n");
		fv_hexdump(mb->b_rptr, 32);
	}
}

static void
chkrdy_ifrm(IFRAMES *ifrm)
{
	IFRAMES *oifr, *nifr;
	TR_XMIT_PARMS *oxp, *nxp;
	mblk_t *omb, *nmb;
	char *odp, *ndp;
	struct datab *obp, *nbp;
	u_int corel = (u_int)ifrm->correlator;

	nifr = ifrm;
	nxp = &nifr->xmit_parms;
	nmb = (mblk_t*)nxp->xmit_data;
	nbp = nmb->b_datap;
	ndp = nmb->b_rptr;

	if (ifrm->state == TR_IFRM_WAIT_READY) {
		printf("Waited Iframe ready, corel=%x\n", corel);
	} else if (ifrm->state == TR_IFRM_WAIT_ACK) {
		printf("Rexmit Iframe, corel=%x\n", corel);
	} else if (ifrm->state != TR_IFRM_WAIT_COREL) {
		printf("Invalid Iframe ready, corel=%x, stat=%x\n",
			corel, (int)(ifrm->state));
		return;
	}

	oifr = &fvifr0[corel];
	oxp = &oifr->xmit_parms;
	omb = &fvmb0[corel];
	obp =  &fvdp0[corel];
	odp = &fvmd0[corel][0];

	if (!nxp) {
		printf("Bad XP ptr: oxp = %x, nxp = %x\n", oxp, nxp);
	} if (bcmp((char*)oxp, (char*)nxp, sizeof(*nxp))) {
		printf("Iframe XP altered\n");
		printf("nxp:\n");
		fv_hexdump((char*)oxp, sizeof(*oxp));
		printf("oxp:\n");
		fv_hexdump((char*)nxp, sizeof(*nxp));
	}

	if (!nmb) {
		printf("Bad MBLK ptr: omb = %x, nmb = %x\n", omb, nmb);
	} else if (bcmp((char*)omb, (char*)nmb, sizeof(*nmb))) {
		printf("Iframe MBLK altered\n");
		printf("omb:\n");
		fv_hexdump((char*)omb, sizeof(*omb));
		printf("nmb:\n");
		fv_hexdump((char*)nmb, sizeof(*nmb));
	}

	if (!nbp) {
		printf("Bad DATA BLOCK ptr: obp = %x, nbp = %x\n", obp, nbp);
	} else if (bcmp(obp, nbp, 16)) {
		printf("Iframe DATA altered\n");
		printf("obp:\n");
		fv_hexdump((char*)obp, 16);
		printf("nbp:\n");
		fv_hexdump((char*)nbp, 16);
	}

	if (!ndp) {
		printf("Bad DATA ptr: odp = %x, ndp = %x\n", odp, ndp);
	} else if (bcmp(odp, ndp, 32)) {
		printf("Iframe DATA altered\n");
		printf("odp:\n");
		fv_hexdump((char*)odp, 32);
		printf("ndp:\n");
		fv_hexdump((char*)ndp, 32);
	}
}
#endif /* IFRMDBG */

static void
fv_xmit_pend(struct fv_info *fv, u_short sid)
{
	int sts;
	IFRAMES *ifrp;

	/* request pending iframe iff exist */
	ifrp=tr_find_iframe_q(&fv->fv_if,sid,(u_short)TR_IFRM_PENDING);
	if (ifrp == 0) {
		return;
	}

	if ((ifrp->correlator&0x1) == 0) {
		IWMSG(("Held iframe(%x) requested already\n",ifrp->correlator));
		return;
	}
	IWMSG(("Requesting held iframe(%x)\n", ifrp->correlator));
	sts = fv_xmit_iframe(fv, &ifrp->xmit_parms, ifrp);
	if (sts) {
		IWMSG(("Request held iframe(%x) failed\n",ifrp->correlator));
		QDBGUP(fvifx.rfail,1);
	} else {
		QDBGUP(fvifx.rtry,1);
	}
}

/*
 * Handle Iframe request.
 */
static void
fv_ifr_intr(struct mbuf *m0)
{
	__psunsigned_t *bp;
	SSB *ssb;
	LCB *lcb;
	int i, j;
	int s1, s;
	u_short sid;
	LLI_CB *cbp;
	u_short corel;
	struct mbuf *m1;
	struct fv_info *fv;
	IFRAMES *ifrp = 0;

	s1 = spl1();
	s = splimp();
	bp = mtod(m0, __psunsigned_t *);
	fv = (struct fv_info *)(bp[0]);
	ssb = (SSB*)(&bp[1]);
	sid = ssb->ssb_parm1;
	corel = ssb->ssb_parm2 >> 8;

	if ((lcb=tr_find_WR_q(&fv->fv_if,sid))==0) {
#ifdef IWAITDBG
		printf("ifr_intr: NO LCB!!!\n");
#endif
		goto ifr_ret;
	}

	switch(ssb->ssb_stat) {
	case TR_IFRAME_BUILD:
		/* See if it is rexmit request */
		for (i = 0, j = lcb->ifr_first; i < NIFRAMES; i++) {
			if (j == lcb->ifr_last)
				break;
			if (lcb->iframes[j].correlator == corel) {
				ifrp = &lcb->iframes[j];
				QDBGUP(fvifx.rxmit,1);	/* total rexmited */
				break;
			}
			if (++j >= NIFRAMES)
    				j = 0;
		}
		if (!ifrp) {
			/* This is new corel assignment */
			lcb->ifr_pend = 0;
			ifrp = tr_find_iframe_q(&fv->fv_if,sid,
					(u_short)TR_IFRM_WAIT_COREL);
			if (ifrp == 0) {
#ifdef IWAITDBG
				printf("NO BUILD IFRP: sts=%x corel=%x\n",
						(u_int)ssb->ssb_stat,
						(u_int)ssb->ssb_parm2);
#endif
				goto ifr_ret;
			}
		}

		/* board says it's okay to send iframe request now. */
	        ifrp->correlator = corel;
	    	ifrp->state = TR_IFRM_WAIT_ACK;
#ifdef IFRMDBG
		stash_ifrm(ifrp, (u_int)(ifrp->correlator));
#endif
#ifdef IWAITDBG
		if (babble) {
			printf("Build Iframe, corel=%x\n",corel);
			babble--;
		}
#endif
		(void)fvsend((caddr_t)ifrp->xmit_parms.xmit_data,
			fv, ifrp->xmit_parms.frame_type, sid, 
			ifrp->xmit_parms.remote_sap, TR_SNA_PACKET, 
			ifrp->xmit_parms.frame_size, ifrp->correlator, 0);
		QDBGUP(fvifx.wack,1);	/* total IFR xmited */

		/* request pending iframe iff exist */
		if ((lcb->ifr_state==IFR_STATE_OK) && (lcb->ifr_pend==0)) {
			fv_xmit_pend(fv, sid);
		}
		break;

	case TR_IFRAME_WAIT:
		/* board says to wait before sending iframe request. */
		lcb->ifr_pend = 0;
		lcb->ifr_state = IFR_STATE_WAIT;
#ifdef QDBG
		fvifx.stat = TR_IFRM_WAIT_READY;
#endif
		/* See if it is rexmit request */
		for (i = 0, j = lcb->ifr_first; i < NIFRAMES; i++) {
			if (j == lcb->ifr_last)
				break;
			if (lcb->iframes[j].correlator == corel) {
				ifrp = &lcb->iframes[j];
				break;
			}
			if (++j >= NIFRAMES)
    				j = 0;
		}
		if (ifrp == 0) {
			ifrp = tr_find_iframe_q(&fv->fv_if,sid,
					(u_short)TR_IFRM_WAIT_COREL);
			if (ifrp == 0) {
				printf("NO WAIT IFRP: sts=%x corel=%x\n",
						(u_int)ssb->ssb_stat,
						(u_int)ssb->ssb_parm2);
			}
		}
#ifdef IWAITDBG
		babble = 1000;
		printf("Wait Iframe, corel=%x\n", corel);
#endif
		if (ifrp) {
	        	ifrp->correlator = corel;
	    		ifrp->state = TR_IFRM_WAIT_READY;
#ifdef IFRMDBG
			stash_ifrm(ifrp, (u_int)(ifrp->correlator));
#endif
		}
		break;

	case TR_IFRAME_MAX_CMDS:
		printf("Iframe request rejected: more than 127 outstanding iframe requests\n");
		goto xmit_iframe_err;

	case TR_IFRAME_INV_STN:
		printf("Iframe request rejected: Invalid station id\n");
		goto xmit_iframe_err;

	case TR_IFRAME_PROT_ERR:
		printf("Iframe request rejected: Protocol error\n");
xmit_iframe_err:
		m1 = m_vget(M_DONTWAIT, (sizeof(*cbp)+sizeof(*ssb)),MT_DATA);
		if (m1 == 0) {
			DP(("no buf for OPEN_SAP status\n"));
			break;
		}

		cbp = mtod(m1, LLI_CB*);
		cbp->port = fv->fv_unit;
		cbp->command = LLI_CMD_RSP;
		cbp->param_blk = (cbp+1);
		bcopy((char*)ssb, (char*)cbp->param_blk, sizeof(*ssb));
		m1->m_len = (sizeof(*cbp)+sizeof(*ssb));
		fv_lli(m1);
		break;
	default:
		printf("Iframe: unknown ERROR returned = %x\n", ssb->ssb_stat);
		break;
	}

ifr_ret:
	splx(s);
	splx(s1);
	m_freem(m0);
}

/*
 * Handle Iframe xmit status.
 */
static void
fv_ifr_stat(struct mbuf *m0)
{
	__psunsigned_t *bp;
	SSB *ssb;
	LCB *lcb;
	u_short sid;
	u_short count;
	int s1, s, i, j;
	u_short corel;
	IFRAMES *ifrp;
	struct fv_info *fv;

	s1 = spl1();
	s = splimp();
	bp = mtod(m0, __psunsigned_t*);
	fv = (struct fv_info *)(bp[0]);
	ssb = (SSB*)(&bp[1]);
	sid = ssb->ssb_parm1;

	if ((lcb = tr_find_WR_q(&fv->fv_if, sid)) == 0) {
#if defined(IFRMDBG) || defined(IWAITDBG)
		printf("lcb not found for sid=%x\n",(u_int)sid);
#endif
		goto ifs_ret;
	}
	corel = (ssb->ssb_parm2 >> 8);

	if (ssb->ssb_stat & TR_XMIT_I_FRAME_ACK) {
		/* When this bit is set, only sid and count has meaning.
		 * correlator has no meaning */
		count = ssb->ssb_stat & 0xff;
		lcb->ifr_cnt -= (u_int)count;
		ASSERT((int)lcb->ifr_cnt >= 0);
		QDBGUP(fvifx.freed,1);

		for (i = lcb->ifr_first; count > 0; count--) {
			ifrp = &lcb->iframes[i];

			if (ifrp->state != TR_IFRM_WAIT_ACK) {
				printf("Unexpected Iframe ACK: corel=%x\n",
					(int)(ifrp->correlator));
#ifdef IFRMDBG
	if (ifrp->xmit_parms.xmit_data == 0)
		printf("Iframe ACK has no xmit_data\n");
	else
		fv_hexdump(((mblk_t*)ifrp->xmit_parms.xmit_data)->b_rptr,
					(int)32);
#endif
				break;
			}
			if (i == lcb->ifr_last) {
				printf("too many Iframe ACKs\n");
				break;
			}

#ifdef IWAITDBG
		if (babble)
			printf("got ACK for %x\n",(u_int)ifrp->correlator);
#endif
			ifrp->correlator = 0xff;
			ifrp->state = TR_IFRM_NULL;
			if (ifrp->xmit_parms.xmit_data) {
				DP(("freeing iframe info, mblk=%x, index=%x\n",
					ifrp->xmit_parms.xmit_data, i));
	 			freemsg(ifrp->xmit_parms.xmit_data);
				ifrp->xmit_parms.xmit_data = NULL;
			}

			if (++i >= NIFRAMES)
				i = 0;
		}
		lcb->ifr_first = i;
	}

	/* See if ready to take iframe req again */
	if (ssb->ssb_stat & TR_XMIT_I_READY) {
		/* find iframe queue, and call fvsend. */
#ifdef IWAITDBG
		printf("fv: iframe ready, corel=%x\n", corel);
		babble = 0;
#endif
		lcb->ifr_state = IFR_STATE_OK;
#ifdef QDBG
		fvifx.stat = IFR_STATE_OK;
#endif
		for (i = 0, j = lcb->ifr_first; i < NIFRAMES; i++) {
			if (j == lcb->ifr_last)
				break;
			if (lcb->iframes[j].correlator == corel) {
				TR_XMIT_PARMS *xp = &lcb->iframes[j].xmit_parms;
#ifdef IFRMDBG
				chkrdy_ifrm(&lcb->iframes[j]);
#endif
				lcb->iframes[j].state = TR_IFRM_WAIT_ACK;
				(void)fvsend((caddr_t)xp->xmit_data, fv,
						xp->frame_type, sid,
						xp->remote_sap, TR_SNA_PACKET,
						xp->frame_size, corel, 0);
				QDBGUP(fvifx.wack,1);	/* total IFR xmited */
				goto ifs_ret;
			}
			if (++j >= NIFRAMES)
    				j = 0;
		}
		printf("can't find Iframe: corel=%x\n", (int)corel);
		ASSERT(0);
	}

ifs_ret:
	m_freem(m0);

	/* request pending iframe iff exist */
	if ((lcb != 0) && (lcb->ifr_pend==0) &&
	    (lcb->ifr_state == IFR_STATE_OK)) {
		fv_xmit_pend(fv, sid);
	}

	splx(s);
	splx(s1);
}

#ifdef FV_CAF
#if (DBG_LVL >= DBG_LVL_DRV)
static void
fv_dumprbuf(struct fv_info *fv)
{
	int i, j;
	volatile struct tr_rcv_list *rcvlist;
	FVMEM *mem = fv->fv_mem;
	volatile struct tr_iob_header * triobh;

	printf ("n_recv_intrs = %d.\n", fvints.recv);

	printf ("rcvlists=0x%x, rcvlist_first=0x%x, rcvlist_free=0x%x, nfree=%d\n",
		mem->fv_rlist, fv->rcvlist_first, 
		fv->rcvlist_free, fv->n_free_rcvlist);

	rcvlist = mem->fv_rlist;
	for (i = 0; i < TR_RCV_LISTS; i++, rcvlist++) {
		printf ("\nrcv_list[%d]: forward=%x %x, cstat = 0x%x, frame_size=%d.\n",
			i, rcvlist->rcv_fwd_high, rcvlist->rcv_fwd_low,
			rcvlist->rcv_cstat, rcvlist->rcv_frame_size);

		for (j = 0, triobh = &rcvlist->rcv_iobh[0]; j < TR_IOB_HEADERS; j++, triobh++) {
			printf("\tdata_count=%x, data_addr=%x %x.\n",
				triobh->data_count, triobh->address_high,
				triobh->address_low);
		}
	}
}
#endif /* (DBG_LVL >= DBG_DRV) */
#endif
#endif /* !IP20 && !IP22 */
