#ifndef __net_ksoioctl__
#define __net_ksoioctl__
/*
 * Kernel-only 32-bit compatibility ioctl definitions and structs
 */
#if defined(_K64U64) && defined( _KERNEL)

#include <sys/socket.h>
#include <sys/ioctl.h>

/* get ifnet list */
#define	IRIX5_SIOCGIFCONF _IOWR('i',20,struct irix5_ifconf) 

struct irix5_ifconf {
	app32_int_t	ifc_len;
	union {
		app32_ptr_t ifcu_buf;
		app32_ptr_t ifcu_req;
	} ifc_ifcu;
};


/* temp sysctl */
#define	IRIX5_SIOCRTSYSCTL _IOWR('r', 99, struct irix5_rtsysctl)	

struct irix5_rtsysctl {
	app32_ptr_t	name;
	app32_uint_t	namelen;
	app32_ptr_t	oldp;
	app32_int_t	oldlen;
	app32_ptr_t	newp;
	app32_int_t	newlen;
};


typedef struct irix5_ifsec {
	app32_ptr_t ifs_label_max;	/* dominates all dgrams on if   */
	app32_ptr_t ifs_label_min;	/* dominated by all if dgrams 	*/
	__uint32_t  ifs_doi;		/* domain of interpretation	*/
	u_char	    ifs_authority_max;	/* maximum authority allowed	*/
	u_char	    ifs_authority_min;	/* minimum authority permitted	*/
	u_char	    ifs_reserved;	/* must be zero until defined	*/
	u_char	    ifs_idiom;		/* security idiom (see below)	*/
} irix5_ifsec_t;

#endif /* defined(_K64U64) && _KERNEL */

#endif	/* __net_ksoioctl__ */
