#ifndef __sys_ksmt__
#define __sys_ksmt__
/*
 * Kernel-only 32-bit compatibility TCP over FDDI SMT/CMT definitions
 */
#if (defined(sgi) && _K64U64)

#ifdef _KERNEL

/*
 * pointer to user buffers for counters or configuration
 */
typedef struct irix5_smt_sioc {
	app32_int_t	phy;		/* for configuration and state */
	union	{
		app32_ptr_t	conf;
		app32_ptr_t	st;
		app32_uint_t	alarm;
		enum pcm_ls	ls;	/* MAINT line state or ALS */
		app32_ptr_t	d_bec;	/* directed beacon INFO field */
	} smt_ptr_u;
	app32_uint_t	len;
} IRIX5_SMT_SIOC;


#define IRIX5_SIOC_SMTGET_CONF    _IOW('S', 1, IRIX5_SMT_SIOC)
#define IRIX5_SIOC_SMTSET_CONF    _IOW('S', 2, IRIX5_SMT_SIOC)
#define IRIX5_SIOC_SMTGET_ST	  _IOW('S', 3, IRIX5_SMT_SIOC)
#define IRIX5_SIOC_SMT_TRACE	  _IOW('S', 4, IRIX5_SMT_SIOC)
#define IRIX5_SIOC_SMT_ARM	  _IOWR('S',5, IRIX5_SMT_SIOC)
#define IRIX5_SIOC_SMT_MAINT	  _IOW('S', 6, IRIX5_SMT_SIOC)
#define IRIX5_SIOC_SMT_LEM_FAIL   _IOW('S', 7, IRIX5_SMT_SIOC)
#define IRIX5_SIOC_SMT_DIRECT_BEC _IOW('S', 8, IRIX5_SMT_SIOC)


#endif /* _KERNEL */

#endif /* (defined(sgi) && _K64U64) */

#endif	/* __sys_ksmt__ */
