/**************************************************************************
 *									  *
 * 		 Copyright (C) 1995, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

#ifndef __SESMGR_H__
#define __SESMGR_H__

#ifdef __cplusplus
extern "C" {
#endif

#ident	"$Revision: 1.1 $"

struct mac_label;
struct soacl;
struct socket;
struct mbuf;
struct ifnet;

#ifdef _KERNEL

extern int sesmgr_enabled;
extern void sesmgr_init( void );

struct mac_label * sesmgr_get_label(struct socket *);
void sesmgr_set_label(struct socket *, struct mac_label *) ;
struct mac_label * sesmgr_get_sendlabel(struct socket *) ;
void sesmgr_set_sendlabel(struct socket *, struct mac_label *) ;
struct soacl * sesmgr_get_soacl(struct socket *);
void sesmgr_set_soacl(struct socket *, struct soacl *);
uid_t sesmgr_get_uid(struct socket *);
uid_t sesmgr_set_uid(struct socket *, uid_t);
uid_t sesmgr_get_rcvuid(struct socket *);
uid_t sesmgr_set_rcvuid(struct socket *, uid_t);

extern int sesmgr_usrreq( struct socket *, int , struct mbuf *,
					struct mbuf *, struct mbuf *);
extern void sesmgr_confignote( void );
extern int sesmgr_ip_input(struct mbuf *, struct ifnet *);
extern struct mbuf * sesmgr_ip_output(struct ifnet *, struct mbuf *, int *);

/* Define macros choosing stub functions or real functions here */
#define _SESMGR_USRREQ(a,b,c,d,e)  ((sesmgr_enabled)? \
					sesmgr_usrreq(a,b,c,d,e): 0)
#define _SESMGR_CONFIGNOTE()	   ((sesmgr_enabled)? \
					sesmgr_confignote(): (void)0 )
#define _SESMGR_IP_INPUT(a,b)	   ((sesmgr_enabled)? \
					sesmgr_ip_input(a,b): 1)
#define _SESMGR_IP_OUTPUT(a,b,c)   ((sesmgr_enabled)? \
					sesmgr_ip_output(a,b,c): 1)

#endif

#ifdef __cplusplus
}
#endif

struct sesmgr_cipso {
	int		   sm_protocl_id;
	struct	mac_label *sm_label;	/* dominates all data rcvd on socket */
	struct	mac_label *sm_sendlabel;/* label sent by udp_output */
	struct  soacl     *sm_soacl;      /* ACL on socket */
	uid_t              sm_uid;      /* uid sent */
	uid_t              sm_rcvuid;   /* uid received - set by sonewconn */
};

#endif	/* __SYS_CAPABILITY_H_ */
